#include "xsw.h"

 
/*
 *      Print memory stats, reload configuration, or refresh and reclaim
 *	memory.
 */
int CmdMemory(char *arg)
{
        char stringa[PATH_MAX + NAME_MAX + 512];
	xsw_mem_stat_struct buf;

        long    total_mem,
                gui_events_mem,
                img_mem,
                univ_entries_mem,
                obj_mem,
                isref_mem,
                ocsn_mem, 
                vs_labels_mem,
                sc_mem;
                
	int events;
        

        /* Get memory stats. */
        XSWGetProgMemory(&buf);


        /* Calculate memory consumed events. */
        events = OSWEventsPending();
 
        /* Print memory statistics. */
        if((arg == NULL) ? 1 : (arg[0] == '\0'))
        {
            sprintf(stringa,   
 "         total   intimgs    isrefs      objs     ocsns"
            );
            MesgAdd(stringa, xsw_color.standard_text);

            sprintf(stringa,
 "Mem:\
 %9ld\
 %9ld\
 %9ld\
 %9ld\
 %9ld",
                buf.total,
                buf.images,
                buf.isrefs,
                buf.objects,
                buf.ocsns
            );
            MesgAdd(stringa, xsw_color.standard_text);
            
            sprintf(stringa,
 "Ent:\
 %9ld\
 %9d\
 %9ld\
 %9ld\
 %9d",
                (long)(total_objects + total_isrefs + total_ocsns),
                total_images,
                total_isrefs,
                total_objects,
                total_ocsns
            );
            MesgAdd(stringa, xsw_color.standard_text);
        }
        /* ********************************************************** */
        /* Reload files into memory? */
        else if(!strcmp(arg, "reload"))
        {
            sprintf(stringa,
    "Client: Memory reload: Main menu configuration from `%s'...",
                fname.main_menu_conf
            );
            MesgAdd(stringa, xsw_color.standard_text);
            XSWMainMenuLoadFromFile(
                &bridge_win.mm,
                bridge_win.viewscreen, bridge_win.viewscreen_image,
                fname.main_menu_conf
            );
                
            sprintf(stringa,
    "Client: Memory reload: Image set referances from `%s'...",
                fname.isr
            );
            MesgAdd(stringa, xsw_color.standard_text);
            ISRefLoadFromFile(fname.isr);

            sprintf(stringa,
    "Client: Memory reload: Object create script names from: `%s'...",
                fname.ocsn
            );
            MesgAdd(stringa, xsw_color.standard_text);
            OCSLoadFromFile(fname.ocsn);

            sprintf(stringa,
    "Client: Memory reload: Sound scheme from: `%s'...",
                fname.sound_scheme
            );
            MesgAdd(stringa, xsw_color.standard_text);
            SSLoadFromFile(fname.sound_scheme);

            sprintf(stringa,
    "Client: Memory reload: Completed."
            );
            MesgAdd(stringa, xsw_color.standard_text);
        }

        /* ********************************************************** */
        /* Refresh objects in memory. */
        else if(!strcmp(arg, "refresh"))
        {
            XSWReclaimGlobalMemory(True);
        }


        /* ********************************************************** */
 
        /* Recreate the selected weapon viewscreen label. */
        VSDrawUpdateWeaponLabel(
            &bridge_win.vs_weapon_image,
            bridge_win.vs_weapon_buf
        );
 


        return(0);
}
