#include "xsw.h"



int CmdSet(char *arg)
{
	int i;
        char *strptr;

        char stringa[CLIENT_CMD_MAX];

        char prop[CLIENT_CMD_MAX];
        char val[CLIENT_CMD_MAX];


        StringStripSpaces(arg);


        /* Parse argument. */
        strptr = strchr(arg, '=');
        if(strptr == NULL)
        {
            strncpy(prop, arg, CS_DATA_MAX_LEN);
            prop[CLIENT_CMD_MAX - 1] = '\0';

            *val = '\0';
        }
        else
        {
            strncpy(val, strptr + 1, CLIENT_CMD_MAX);
            val[CLIENT_CMD_MAX - 1] = '\0';
            StringStripSpaces(val);

            *strptr = '\0';
            strncpy(prop, arg, CLIENT_CMD_MAX);
            prop[CLIENT_CMD_MAX - 1] = '\0';
            StringStripSpaces(prop);
        }


        /* Print all settings? */
        if(*val == '\0')
        {
            /* auto_interval */
            if((*prop == '\0') ||
               !strcmp(prop, "auto_interval")
            )
            {
                sprintf(stringa, "auto_interval = %s",
                    (auto_interval_tune.state) ? "on" : "off"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* auto_map_eco_win */
            if((*prop == '\0') ||
               !strcmp(prop, "auto_map_eco_win")
            )
            {
                sprintf(stringa, "auto_map_eco_win = %s",
                    (option.auto_map_eco_win) ? "yes" : "no"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* auto_map_univ_list_win */
            if((*prop == '\0') ||
               !strcmp(prop, "auto_map_univ_list_win")
            )
            {
                sprintf(stringa, "auto_map_univ_list_win = %s",
                    (option.auto_map_univ_list_win) ? "yes" : "no"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* auto_zoom */
            if((*prop == '\0') ||
               !strcmp(prop, "auto_zoom")
            )
            {
                sprintf(stringa, "auto_zoom = %s",
                    (option.auto_zoom) ? "on" : "off"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }


            /* control_type */
            if((*prop == '\0') ||
               !strcmp(prop, "controller")
            )
	    {
	        switch(option.controller)
	        {
                  case CONTROLLER_POINTER:
                    sprintf(stringa, "control_type = pointer");
		    break;

	          case CONTROLLER_KEYBOARD:
                    sprintf(stringa, "control_type = keyboard");
		    break;

#ifdef JS_SUPPORT
                  case CONTROLLER_JOYSTICK:
                    sprintf(stringa, "control_type = joystick");
		    break;
#endif /* JS_SUPPORT */

                  default:
                    sprintf(stringa, "control_type = *badvalue*");
		    break;
	        }
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* display_events */
            if((*prop == '\0') ||
               !strcmp(prop, "display_events")
            )
            {
		sprintf(stringa, "display_events = %s",
                    (option.display_events) ? "yes" : "no"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* energy_saver_mode */
            if((*prop == '\0') ||
               !strcmp(prop, "energy_saver_mode")
            )
            {
                sprintf(stringa, "energy_saver_mode = %s",
                    (option.energy_saver_mode) ? "yes" : "no"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* local_updates */
            if((*prop == '\0') ||
               !strcmp(prop, "local_updates")
            )
            {
                sprintf(stringa, "local_updates = %s",
                    (option.local_updates) ? "on" : "off"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* log_client */
            if((*prop == '\0') ||
               !strcmp(prop, "log_client")
            )
            {
                sprintf(stringa, "log_client = %s",
                    (option.log_client) ? "on" : "off"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* log_net */
            if((*prop == '\0') ||
               !strcmp(prop, "log_net")
            )
            {
                sprintf(stringa, "log_net = %s",
                    (option.log_net) ? "on" : "off"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* log_errors */
            if((*prop == '\0') ||
               !strcmp(prop, "log_errors")
            )
            {
                sprintf(stringa, "log_errors = %s",
                    (option.log_errors) ? "on" : "off"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* login_name */
            if((*prop == '\0') ||
               !strcmp(prop, "login_name")
            )
            {
	        sprintf(stringa, "login_name = %s",
		    net_parms.login_name
	        );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* login_password */
            if((*prop == '\0') ||
               !strcmp(prop, "login_password")
            )
            {
	        sprintf(stringa, "login_password = %s",
		    net_parms.login_password
	        );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* net_interval */
            if((*prop == '\0') ||
               !strcmp(prop, "net_int")
            )
            {
                sprintf(stringa, "net_int = %i",
                    (int)net_parms.net_int
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* net_load_max */
            if((*prop == '\0') ||
               !strcmp(prop, "net_load_max")
            )
            {
                sprintf(stringa, "net_load_max = %ld",
                    loadstat.net_load_max
		);
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* notify_scanner_contacts */
            if((*prop == '\0') ||
               !strcmp(prop, "notify_scanner_contacts")
            )
            {
                sprintf(stringa, "notify_scanner_contacts = %s",
                    (option.notify_scanner_contacts) ? "on" : "off"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
            }

	    /* show_formal_label */
            if((*prop == '\0') ||
               !strcmp(prop, "show_formal_label")
            )
            {
	        switch(option.show_formal_label)
	        {
	          case 0:
		    sprintf(stringa, "show_formal_label = no");
                    break;

                  case 1:
                    sprintf(stringa, "show_formal_label = as needed");
                    break;

                  case 2:
                    sprintf(stringa, "show_formal_label = yes");
                    break;

                  default:
                    sprintf(stringa, "show_formal_label = *bad value*");
                    break;
	        }
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* show_lens_flares */
            if((*prop == '\0') ||
               !strcmp(prop, "show_lens_flares")
            )
            {
                sprintf(stringa, "show_lens_flares = %s",
                    ((option.show_lens_flares) ? "yes" : "no")
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* show_nebula_glow */
            if((*prop == '\0') ||
               !strcmp(prop, "show_nebula_glow")
            )
            {
                sprintf(stringa, "show_nebula_glow = %s",
                    ((option.show_nebula_glow) ? "yes" : "no")
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
            }

	    /* show_net_errors */
            if((*prop == '\0') ||
               !strcmp(prop, "show_net_errors")
            )
            {
                sprintf(stringa, "show_net_errors = %s",
                    (option.show_net_errors) ? "yes" : "no"
	        );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* show_viewscreen_labels */
            if((*prop == '\0') ||
               !strcmp(prop, "show_viewscreen_labels")
            )
            {
	        switch(option.show_viewscreen_labels)
	        {
	          case 0:
		    sprintf(stringa, "show_viewscreen_labels = none");
		    break;

                  case 1:
                    sprintf(stringa, "show_viewscreen_labels = labels");
                    break;

                  case 2:
                    sprintf(stringa, "show_viewscreen_labels = stats"); 
                    break;

                  case 3:
                    sprintf(stringa, "show_viewscreen_labels = all"); 
                    break;

                  default:
                    sprintf(stringa, "show_viewscreen_labels = *bad value*"); 
                    break;
	        }
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* show_strobe_glow */
            if((*prop == '\0') ||
               !strcmp(prop, "show_strobe_glow")
            )
            {
                sprintf(stringa, "show_strobe_glow = %s",
                    ((option.show_strobe_glow) ? "yes" : "no")
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
            }

            /* show_viewscreen_marks */
            if((*prop == '\0') ||
               !strcmp(prop, "show_viewscreen_marks")
            )
            {
                sprintf(stringa, "show_viewscreen_marks = %s",
                    (option.show_viewscreen_marks) ? "yes" : "no"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* scanner_limiting */
            if((*prop == '\0') ||
               !strcmp(prop, "scanner_limiting")
            )
            {
                sprintf(stringa, "scanner_limiting = %s",
                    (option.scanner_limiting) ? "yes" : "no"
                );
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* sounds */
            if((*prop == '\0') ||
               !strcmp(prop, "sounds")
            )
            {
	        switch(option.sounds)
	        {
                  case XSW_SOUNDS_NONE:
                    sprintf(stringa, "sounds = off");
		    break;

                  case XSW_SOUNDS_EVENTS:
                    sprintf(stringa, "sounds = events");
                    break;

                  case XSW_SOUNDS_ENGINE:
                    sprintf(stringa, "sounds = engine");               
                    break;

                  case XSW_SOUNDS_ALL:
                    sprintf(stringa, "sounds = all");
                    break;

                  default:
                    sprintf(stringa, "sounds = *bad value*");
                    break;
	        }
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* throttle_mode */
            if((*prop == '\0') ||
               !strcmp(prop, "throttle_mode")
            )
            {
                switch(option.throttle_mode)
                {
		  case THROTTLE_MODE_INCREMENTAL:
                    sprintf(stringa, "throttle_mode = incremental");
                    break;

                  case THROTTLE_MODE_BIDIRECTIONAL:
                    sprintf(stringa, "throttle_mode = bidirectional");
                    break; 

                  case THROTTLE_MODE_NORMAL:
                    sprintf(stringa, "throttle_mode = normal");
                    break;

                  default:
                    sprintf(stringa, "throttle_mode = *badvalue*");
                    break;
                }
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

            /* units */
            if((*prop == '\0') ||
               !strcmp(prop, "units")
            )
            {
	        switch(option.units)
	        {
	          case XSW_UNITS_XSW:
                    sprintf(stringa, "units = XSW");
		    break;

                  case XSW_UNITS_METRIC:
                    sprintf(stringa, "units = AstroMetric");
                    break;

                  case XSW_UNITS_ENGLISH:
                    sprintf(stringa, "units = English");
                    break;

                  default:
                    sprintf(stringa, "units = *vad value*");
                    break;
		}
                MesgAdd(stringa, xsw_color.bp_standard_text);
	    }

	    /* Print usage. */
            MesgAdd("Usage: set <property>=<value>",
               xsw_color.bp_standard_text
            );
            return(0);
        }

	/* ************************************************************** */

        /* auto_interval */
        if(strpfx(prop, "auto_i") ||
           strpfx(prop, "autoi") ||
           strpfx(prop, "aint")
        )
        {
            if(val[0] != '\0')
	    {
                auto_interval_tune.state = StringIsYes(val);
	    }

	    sprintf(stringa, "auto_interval = %s",
		(auto_interval_tune.state) ? "on" : "off"
	    );
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
	/* local_updates */
        else if(strpfx(prop, "local_u") ||
                strpfx(prop, "localu") ||
                strpfx(prop, "lu")
        )       
        {
            if(val[0] != '\0')
            {
                option.local_updates = StringIsYes(val);
 	    }

            sprintf(stringa, "local_updates = %s",
                (option.local_updates) ? "on" : "off"
	    );
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
        /* control_type */
        else if(strpfx(prop, "control_t") ||
                strpfx(prop, "control") 
        )
        {
            if(val[0] != '\0')
            {
                if(strcasepfx(val, "p"))
                {
                    option.controller = CONTROLLER_POINTER;
                }
                else if(strcasepfx(val, "k"))
                {
                    option.controller = CONTROLLER_KEYBOARD;
                }
#ifdef JS_SUPPORT
                else if(strcasepfx(val, "j"))
                {
                    option.controller = CONTROLLER_JOYSTICK;
                }
#endif /* JS_SUPPORT */
                else  
                {
#ifdef JS_SUPPORT
                    MesgAdd(
             "Available control_type values: pointer  keyboard joystick",
                        xsw_color.bp_standard_text
                    );
#else
                    MesgAdd(
              "Available control_type values: pointer  keyboard",
                        xsw_color.bp_standard_text
                    );
#endif /* JS_SUPPORT */ 

                    return(-2);
                }

                /*   Change over to and initialize game controller.
                 *   Global option.controller will be re-updated by this
                 *   call!
                 */
                GCtlInit(option.controller);
            }

            switch(option.controller)   
            {
              case CONTROLLER_POINTER:
                sprintf(stringa, "control_type = pointer");
                break;

              case CONTROLLER_KEYBOARD:
                sprintf(stringa, "control_type = keyboard"); 
                break;

#ifdef JS_SUPPORT   
              case CONTROLLER_JOYSTICK:
                sprintf(stringa, "control_type = joystick");
                break;
#endif /* JS_SUPPORT */

              default:
                sprintf(stringa, "control_type = *badvalue*");
                break;
            }
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
	/* login_name */
	else if(strpfx(prop, "login_n") ||
                strpfx(prop, "loginn") ||
                strpfx(prop, "ln")
	)
	{
	    if(val[0] != '\0')
	    {
                /* Set login name. */
                StringStripSpaces(val);
                strncpy(net_parms.login_name, val, XSW_OBJ_NAME_MAX);
                net_parms.login_name[XSW_OBJ_NAME_MAX - 1] = '\0';
	    }

            switch(DBValidateObjectName(net_parms.login_name))
            {
              case -1:
		sprintf(stringa,
		    "%s: Invalid name.",
                    net_parms.login_name
                );
                break;

              case 1:
                sprintf(stringa,
                    "%s: Name too long.",
                    net_parms.login_name
                );
                break;

              case 2:
                sprintf(stringa,
	            "%s: Name too short.",
                    net_parms.login_name
                );
                break;

              case 3:
                sprintf(stringa,
                    "%s: Name contains invalid character(s).",
                    net_parms.login_name
                );
                break;

	      default:
                sprintf(stringa,
                    "login_name = %s",
                    net_parms.login_name
                );
		break;
	    }
            MesgAdd(stringa, xsw_color.bp_standard_text);
	}
	/* login_password */
        else if(strpfx(prop, "login_p") ||
                strpfx(prop, "loginp") ||
                strpfx(prop, "lp")
	)
        {
            if(val[0] != '\0')
            {
                /* Set login password. */
                StringStripSpaces(val);
                strncpy(net_parms.login_password, val, XSW_OBJ_PASSWORD_MAX);
                net_parms.login_password[XSW_OBJ_PASSWORD_MAX - 1] = '\0';
	    }

	    switch(DBValidateObjectPassword(net_parms.login_password))
	    {
              default:
                sprintf(stringa,
                    "login_password = %s",
                    net_parms.login_password
                );
                break;
            }
	    MesgAdd(stringa, xsw_color.bp_standard_text);
	}
	/* net_interval */
        else if(strpfx(prop, "net_i") ||
                strpfx(prop, "int")
        )
        {   
            /* Not connected? */
            if(net_parms.connection_state != CON_STATE_CONNECTED)
            {
                MesgAdd("net_interval: Not connected.",
                    xsw_color.bp_standard_text
                );
                return(-3);
            }
            else if(val[0] != '\0')
            {
                net_parms.net_int = atol(val);
            }   
            
            /* Sanitize net interval. */
            if(net_parms.net_int > MAX_SERVER_UPDATE_INT) 
                net_parms.net_int = MAX_SERVER_UPDATE_INT;
            if(net_parms.net_int < MIN_SERVER_UPDATE_INT) 
                net_parms.net_int = MIN_SERVER_UPDATE_INT;
            
            sprintf(stringa,
                "net_interval = %ld",
                net_parms.net_int
            );
            MesgAdd(stringa, xsw_color.bp_standard_text);
            
            /* Send new interval to server. */
            NetSendSetInterval();
        }
        /* net_load_max */   
        else if(strpfx(prop, "net_load_m") ||
                strpfx(prop, "netloadm")   
        )
        {
            if(val[0] != '\0')
            {
                loadstat.net_load_max = atol(val);  
            }
            if(loadstat.net_load_max < 800)
                loadstat.net_load_max = 800;

            sprintf(stringa,
                "net_load_max = %ld",
                loadstat.net_load_max
            );
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
	/* notify_scanner_contacts */
        else if(strpfx(prop, "notify_s"))
        {
            if(val[0] != '\0')
            {
                option.notify_scanner_contacts = StringIsYes(val);
            }

            sprintf(stringa, "notify_scanner_contacts = %s",
                (option.notify_scanner_contacts) ? "on" : "off"
            );
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
        /* show_lens_flares */
        else if(strpfx(prop, "show_lens"))
        {
            if(val[0] != '\0')
            {
                option.show_lens_flares = StringIsYes(val);
            }

            sprintf(stringa, "show_lens_flares = %s",
                ((option.show_lens_flares) ? "yes" : "no")
            );
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
        /* show_nebula_glow */
        else if(strpfx(prop, "show_nebula_g"))
        {
            if(val[0] != '\0')
            {
                option.show_nebula_glow = StringIsYes(val);
            }

            sprintf(stringa, "show_nebula_glow = %s",
                ((option.show_nebula_glow) ? "yes" : "no")
            );
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
        /* show_strobe_glow */
        else if(strpfx(prop, "show_strobe_g"))
        {
            if(val[0] != '\0')
            {
                option.show_strobe_glow = StringIsYes(val);
            }

            sprintf(stringa, "show_strobe_glow = %s",
                ((option.show_strobe_glow) ? "yes" : "no")
            );
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
        /* show_net_errors */
        else if(strpfx(prop, "show_net_e") ||
                strpfx(prop, "shownete")   
        )
        {
            if(val[0] != '\0')
            {
                option.show_net_errors = StringIsYes(val);
            }   
                
            sprintf(stringa,
                "show_net_errors = %s",
                (option.show_net_errors) ? "yes" : "no"
            );    
            MesgAdd(stringa, xsw_color.bp_standard_text);
        }
	/* sound */
	else if(strpfx(prop, "sou") ||
                strpfx(prop, "snd")
	)
	{
            if(val[0] != '\0')
            {
		if(!strcmp(val, "none") ||
                   !strcmp(val, "off") ||
                   !strcmp(val, "0")
		)
		{
                    i = XSW_SOUNDS_NONE;
		}
		else if(!strcmp(val, "events"))
		{
		    i = XSW_SOUNDS_EVENTS;
		}
                else if(!strcmp(val, "engines") ||
                        !strcmp(val, "engine")
		)
                {
                    i = XSW_SOUNDS_ENGINE;
                }
                else if(!strcmp(val, "all") ||
                        !strcmp(val, "on")
		)
                {
                    i = XSW_SOUNDS_ALL;
                }
		else
		{
		    /* Print available values. */
		    MesgAdd(
             "Available sounds values: none  events  engines  all",
			xsw_color.bp_standard_text
		    );
		    return(-2);
		} 

                /* Need to initialize sound? */
                if((sound.con_data == NULL) &&
                   (i > XSW_SOUNDS_NONE)
                )
                {
                    /* Set new sounds value. */
                    option.sounds = i;

		    /* Initialize sound. */
                    if(SoundInit())
                    {
                        MesgAdd(
			    "sounds: Cannot initialize.",
                            xsw_color.bp_standard_text
			);
                        option.sounds = XSW_SOUNDS_NONE;
                        return(-1);
                    }
                }
                /* Need to shutdown sound? */
                else if((sound.con_data != NULL) &&
                        (i <= XSW_SOUNDS_NONE)
                )
                {
                    /* Set new sounds value. */
                    option.sounds = i;

		    /* Shutdown sound. */
                    SoundShutdown();
                }

		/* Set new sounds value. */
                option.sounds = i;
	    }

            switch(option.sounds)
            {
              case XSW_SOUNDS_NONE:
                sprintf(stringa, "sounds = off");
                break;
                
              case XSW_SOUNDS_EVENTS:
                sprintf(stringa, "sounds = events");
                break;
                
              case XSW_SOUNDS_ENGINE:
                sprintf(stringa, "sounds = engine");
                break;
                
              case XSW_SOUNDS_ALL:
                sprintf(stringa, "sounds = all");
                break;
                
              default:
                sprintf(stringa, "sounds = *bad value*");
                break;
            }
	    MesgAdd(stringa, xsw_color.bp_standard_text);
	}
	/* throttle_mode */
        else if(strpfx(prop, "throttle_s") ||
                strpfx(prop, "throttles")
	)
        {
            if(val[0] != '\0')
            {
		if(strcasepfx(val, "i"))
                    option.throttle_mode = THROTTLE_MODE_INCREMENTAL;
                else if(strcasepfx(val, "b"))
                    option.throttle_mode = THROTTLE_MODE_BIDIRECTIONAL;
                else if(strcasepfx(val, "n"))
                    option.throttle_mode = THROTTLE_MODE_NORMAL;
		else
                {
		    MesgAdd(
 "Available throttle_mode values: normal  bidirectional  incremental",
			xsw_color.bp_standard_text
		    );
		    return(-2);
                }
	    }
	    switch(option.throttle_mode)
	    {
              case THROTTLE_MODE_INCREMENTAL:
                sprintf(stringa, "throttle_mode = incremental");
                break;

	      case THROTTLE_MODE_BIDIRECTIONAL:
		sprintf(stringa, "throttle_mode = bidirectional");
		break;

	      case THROTTLE_MODE_NORMAL:
                sprintf(stringa, "throttle_mode = normal");
		break;

	      default:
                sprintf(stringa, "throttle_mode = *badvalue*");
		break;
	    }
            MesgAdd(stringa, xsw_color.bp_standard_text);
	}
        /* units */
        else if(strpfx(prop, "unit"))
        {
            if(val[0] != '\0')
            {
                if(strcasepfx(val, "xsw"))
                {
                    option.units = XSW_UNITS_XSW;
                }
                else if(strcasepfx(val, "Metric") ||
                        strcasepfx(val, "AstroMetric")
		)
		{
                    option.units = XSW_UNITS_METRIC;
		}
                else if(strcasepfx(val, "English"))
                {
                    option.units = XSW_UNITS_ENGLISH;
                }
                else
                {
                    MesgAdd(
      "Available units values: english  metric  xsw",
                        xsw_color.bp_standard_text
                    );
                    return(-2);
                }

		/* Need to redraw scanner. */
		ScannerUpdateLabels(lplayer_object);
            }

            switch(option.units)
            {
              case XSW_UNITS_XSW:
                sprintf(stringa, "units = XSW");
                break;

              case XSW_UNITS_METRIC:
                sprintf(stringa, "units = metric");
                break;

              case XSW_UNITS_ENGLISH:
                sprintf(stringa, "units = english");
                break;

              default:
                sprintf(stringa, "units = *vad value*");
                break;
            }
            MesgAdd(stringa, xsw_color.bp_standard_text);
	}





	else
	{
	    sprintf(stringa, "%s: Unsupported or read only property.", prop);
            MesgAdd(stringa, xsw_color.bp_standard_text);
	    return(-2);
	}


	/* ********************************************************** */

	/* Need to redraw things that may reflect changes. */
	BridgeWinDrawAll();


	return(0);
}
