/*
                        Image paths and values

	Global images directory should be prepended by program
	to all paths here that are not absolute paths.

	Note: Image codes are in xsw.h.

 */

#ifndef IMAGEPATHS_H
#define IMAGEPATHS_H


/* Icons. */
#define IMGPATH_ICON_BRIDGE	"icons/bridge.tga"
#define IMGPATH_ICON_ECONOMY	"icons/economy.tga"
#define IMGPATH_ICON_MESSAGES	"icons/messages.tga"
#define IMGPATH_ICON_OPTIONS	"icons/options.tga"
#define IMGPATH_ICON_UNIVERSE	"icons/universe.tga"


/* Splash background. */
#define IMGPATH_SPLASH_BKG	"client/splash_bkg.tga"
#define IMGPATH_SPLASH_PB_L	"client/splash_pb_l.tga"
#define IMGPATH_SPLASH_PB_R	"client/splash_pb_r.tga"
#define IMGPATH_SPLASH_PB_T	"client/splash_pb_t.tga"


/* Viewscreen superimposed target marks. */
#define IMGPATH_VS_TMARK_OBJECT	"client/vs_tmark_object.tga"
#define IMGPATH_VS_TMARK_VESSEL	"client/vs_tmark_vessel.tga"
#define IMGPATH_VS_MARK_INCOMINGFIRE	"client/vs_mark_incoming_fire.tga"
#define IMGPATH_VS_WEP_PROJECTILE	"client/vs_wep_projectile.tga"
#define IMGPATH_VS_WEP_PULSE		"client/vs_wep_pulse.tga"
#define IMGPATH_VS_WEP_STREAM		"client/vs_wep_stream.tga"

/* Scanner marks. */
#define IMGPATH_SCMARK_UNKNOWN	"client/scanner_mark_unknown.tga"
#define IMGPATH_SCMARK_LOCKED	"client/scanner_mark_locked.tga"
#define IMGPATH_SCMARK_WEAPON	"client/scanner_mark_weapon.tga"
#define IMGPATH_SCMARK_HOME	"client/scanner_mark_home.tga"
#define IMGPATH_SCMARK_AREA	"client/scanner_mark_area.tga"

/* Bridge console panel backgrounds. */
#define IMGPATH_BPANEL_L1	"client/bpanel_l1.tga"
#define IMGPATH_BPANEL_L2	"client/bpanel_l2.tga"
#define IMGPATH_BPANEL_L3	"client/bpanel_l3.tga"
#define IMGPATH_BPANEL_L4	"client/bpanel_l4.tga"
#define IMGPATH_BPANEL_R1	"client/bpanel_r1.tga"
#define IMGPATH_BPANEL_R2	"client/bpanel_r2.tga"
#define IMGPATH_BPANEL_R3	"client/bpanel_r3.tga"
#define IMGPATH_BPANEL_R4	"client/bpanel_r4.tga"
#define IMGPATH_BPANEL_MESG	"client/bpanel_mesg.tga"

/* Bridge console panel outlines. */
#define IMGPATH_BPANEL_OL_HULL		"client/bpanel_ol_hull.tga"
#define IMGPATH_BPANEL_OL_POWER		"client/bpanel_ol_power.tga"
#define IMGPATH_BPANEL_OL_VIS		"client/bpanel_ol_vis.tga"
#define IMGPATH_BPANEL_OL_SHIELDS	"client/bpanel_ol_shields.tga"
#define IMGPATH_BPANEL_OL_DMGCTL	"client/bpanel_ol_dmgctl.tga"

#define IMGPATH_BPANEL_OL_THROTTLE_L	"client/bpanel_ol_throttlel.tga"
#define IMGPATH_BPANEL_OL_THROTTLE_R	"client/bpanel_ol_throttler.tga"

#define IMGPATH_BPANEL_OL_THRUSTVECTOR	"client/bpanel_ol_thrustvector.tga"

/* Large message screen background. */
#define IMGPATH_MESG_SCR_BKG	"client/mesg_scr_bkg.tga"


/* Misc. */
#define IMGPATH_LENSFLARE1	"client/lensflare1.tga"
#define IMGPATH_LENSFLARE2	"client/lensflare2.tga"

#define IMGPATH_STROBEGLOW1	"client/strobeglow1.tga"




#endif	/* IMAGEPATHS_H */
