/*
                         X Operating System Wrapper

	Macros:



	Init:

	int OSWGUIConnect(int argc, char *argv[])
	void OSWGUIDisconnect()
	int OSWLoadKeyCodes()


	Keycodes:

	char OSWGetASCIIFromKeyCode(
		keycode_t keycode,
		bool_t shift,
		bool_t alt,
		bool_t ctrl
	)
	char *OSWGetKeyCodeName(keycode_t keycode)
	void OSWManageEvent(event_t *event)
        int OSWIsModifierKey(keycode_t keycode)


	GUI systems and runtime:

	void OSWGUISync(bool_t discard)
	void OSWGetPointerCoords(
	        win_t w,
	        int *root_x, int *root_y,
	        int *wx, int *wy
	)
	void OSWGrabPointer(
		win_t grab_w,
		bool_t events_rel_grab_w,
		eventmask_t eventmask,
		int pointer_mode, int keyboard_mode,
		win_t confine_w,
		cursot_t cursor
	)
	void OSWUngrabPointer()
	void OSWGUIFree(void **ptr)
	void *OSWFetchDDE(int *bytes)
	void OSWPutDDE(void *buf, int bytes)
	visual_t *OSWGetVisualByCriteria(
	        long vinfo_mask,
	        visual_info_t criteria_vinfo
	)
	visual_t *OSWGetVisualByID(visual_id_t vid) 
	void OSWKBAutoRepeatOff()
        void OSWKBAutoRepeatOn()


	Fonts:

	int OSWLoadFont(font_t **font, char *fontname)
	font_t *OSWQueryCurrentFont()
	void OSWSetFont(font_t *font)
	void OSWUnloadFont(font_t **font)


	Pixels (color allocation):

	int OSWLoadPixelRGB(pixel_t *pix_rtn,
		u_int8_t r,
		u_int8_t g,
		u_int8_t b
	)
        int OSWLoadPixelHSL(pixel_t *pix_rtn,
                u_int8_t h,
                u_int8_t s,
                u_int8_t l
        )
	int OSWLoadPixelCLSP(pixel_t *pix_rtn, char *clsp)
	void OSWDestroyPixel(pixel_t *pix_ptr)

	void OSWSetFgPix(pixel_t pix)


	Cursor (pointer cursor):

	cursor_t OSWLoadBasicCursor(cur_code_t code)
	void OSWSetWindowCursor(win_t w, cursor_t cursor)
	void OSWDestroyCursor(cursor_t *cursor)


	Events:

	int OSWEventsPending()
	void OSWWaitNextEvent(event_t *event)
        void OSWWaitPeakEvent(event_t *event)
	bool_t OSWCheckMaskEvent(eventmask_t eventmask, event_t *event)
	void OSWWaitWindowEvent(
		win_t w, eventmask_t event_mask, event_t *event
	)
	bool_t OSWCheckWindowEvent(
		win_t w, eventmask_t event_mask, event_t *event
	)
	void OSWPutBackEvent(event_t *event)
	int OSWSendEvent(
	        eventmask_t mask,
	        event_t *event,   
	        bool_t propagate
	)
	int OSWPurgeAllEvents()
	int OSWPurgeOldMotionEvents()
	int OSWPurgeTypedEvent(int event_type)
	int OSWPurgeWindowTypedEvent(win_t w, eventtype_t event_type)

	int OSWIsEventDestroyWindow(win_t w, event_t *event)


	Window:

	int OSWCreateWindow(
	        win_t *w,
	        win_t parent,
	        int x, int y,
	        unsigned int width, unsigned int height
	)
	void OSWDestroyWindow(win_t *w)
	void OSWSetWindowIcon(win_t w, pixmap_t icon, bool_t has_transparency)
	void OSWSetWindowWMProperties(
	        win_t w,
	        char *title,
	        char *icon_title,
	        pixmap_t icon,
	        bool_t wm_sets_coordinates,
		int x, int y,
	        unsigned int min_width, unsigned int min_height,
	        unsigned int max_width, unsigned int max_height,
	        int frame_style,
	        char **argv, int argc
	)
	void OSWSetWindowInput(win_t w, eventmask_t eventmask)
	void OSWSetTransientFor(win_t wbum, win_t wshelter)
	void OSWMapWindow(win_t w)
	void OSWMapRaised(win_t w)
	void OSWMapSubwindows(win_t w)
	void OSWUnmapWindow(win_t w)
	void OSWRestackWindows(win_t *w, int num_w)
	int OSWIconifyWindow(win_t w)
	void OSWReparentWindow(win_t w, win_t parent);
	void OSWMoveWindow(win_t w, int x, int y)
	void OSWResizeWindow(win_t w, unsigned int width, unsigned int height)
	void OSWMoveResizeWindow(win_t w, int x, int y,
	        unsigned int width, unsigned int height)
	void OSWSetWindowTitle(Window w, char *title)
	void OSWClearWindow(win_t w)
	void OSWSetWindowBkg(win_t w, pixel_t pix, pixmap_t pixmap)
	int OSWGetWindowAttributes(win_t w, win_attr_t *wattr)
	int OSWGetWindowRootPos(win_t w, int *x, int *y);
	win_t OSWGetWindowParent(win_t w)
	bool_t OSWCheckWindowAncestory(win_t grand_parent, win_t grand_child)


	Pixmap (graphics buffer):
  
	int OSWCreatePixmap(pixmap_t *pixmap, unsigned int width,
		unsigned int height)
	void OSWDestroyPixmap(pixmap_t *pixmap)
	void OSWClearPixmap(pixmap_t pixmap, unsigned int width,
		unsigned int height, pixel_t pix)

	Images:

	int OSWCreateImage(
	        image_t **image,
	        unsigned int width, unsigned int height
	)
	void OSWDestroyImage(image_t **image)


	Shared images:

	int OSWCreateSharedImage(
	        shared_image_t **image,
	        unsigned int width,
	        unsigned int height
	)
	void OSWDestroySharedImage(
	        shared_image_t **image
	)


	Graphics conversions:

	pixmap_t OSWCreatePixmapFromImage(image_t *image)


	Graphics IO:

        image_t *OSWGetImage(drawable_t d, int x, int y,
		unsigned int width, unsigned int height)
	void OSWPutImageToDrawable(image_t *image, drawable_t d)
	void OSWPutImageToDrawablePos(
		image_t *image, drawable_t d,
		int tar_x, int tar_y
	)
	void OSWPutImageToDrawableSect(
	        image_t *image, drawable_t d,
	        int tar_x, int tar_y,
	        int src_x, int src_y,
	        unsigned int width, unsigned int height
	)
	void OSWPutSharedImageToDrawable(
		shared_image_t *image,
		drawable_t d
	)
	void OSWPutSharedImageToDrawablePos(
		shared_image_t *image, drawable_t d,
		int tar_x, int tar_y
	)
	void OSWPutSharedImageToDrawableSect(
	        shared_image_t *image, drawable_t d,
	        int tar_x, int tar_y,
	        int src_x, int src_y,
	        unsigned int width, unsigned int height
	)
	void OSWSyncSharedImage(shared_image_t *image, drawable_t d)
	void OSWPutBufferToWindow(win_t w, gbuf_t gbuf)
	void OSWCopyDrawables(
	    drawable_t tar_d,
	    drawable_t src_d,
	    unsigned int width,
	    unsigned int height
	)
        void OSWCopyDrawablesCoord(
            drawable_t tar_d,
            drawable_t src_d,
	    int tar_x, int tar_y,
	    unsigned int width, unsigned int height,
            int src_x, int src_y
        )


	Drawing:

	void OSWDrawString(drawable_t d, int x, int y, char *string)
	void OSWDrawStringLimited(drawable_t d, int x, int y, char *string,
	        int len)
	void OSWDrawLine(drawable_t d, int start_x, int start_y,
	        int end_x, int end_y)
	void OSWDrawRectangle(drawable_t d, int x, int y,
	        unsigned int width, unsigned int height)
	void OSWDrawSolidRectangle(drawable_t d, int x, int y,
	        unsigned int width, unsigned int height)
	void OSWDrawArc(drawable_t d, int x, int y,
	        unsigned int width, unsigned int height,
	        double position_angle,
	        double terminal_angle
	)
	void OSWDrawSolidArc(drawable_t d, int x, int y,
	        unsigned int width, unsigned int height,
	        double position_angle,
	        double terminal_angle
	)


	Misc:

	int OSWXErrorHandler(  
	        Display *da_display,
	        XErrorEvent *da_error_event
	)


*/

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>   
#include <string.h>
#include <unistd.h>
#include <db.h>
#include <sys/types.h>


/* OS Makeup. */
#include "../include/os.h"

/* Byte packing and bytes per pixel. */
#include "../include/graphics.h"

#include "../include/string.h"

#include "../include/osw-x.h"

/* Needed for OSWSetWindowWMProperties(). */
#include "../include/MwmUtil.h"


#define MIN(a,b)        ((a) < (b) ? (a) : (b))
#define MAX(a,b)        ((a) > (b) ? (a) : (b))



osw_gui_struct osw_gui[1];
osw_keycode_struct osw_keycode;
osw_atom_struct osw_atom;
osw_icon_record_struct *osw_icon_record;
int osw_total_icon_records;



/*
 *	XShmGetEventBase() needs to be prototyped,
 *	it is apparently not defined in any of the available
 *	header files.
 */
extern int XShmGetEventBase(Display *display);


/*
 *	GUI Error handler.
 */
int OSWXErrorHandler(  
	Display *da_display,
	XErrorEvent *da_error_event
);

/*
 *	GUI wrapper's local event manager.
 */
void OSWManageEvent(event_t *event);

/*
 *	GUI wrapper's function for setting WM icons on toplevel windows.
 */
void OSWSetWindowIcon(win_t w, pixmap_t icon, bool_t has_transparency);


/*
 *	Connect to GUI.
 */
int OSWGUIConnect(int argc, char *argv[])
{
	osw_gui_struct *gui;
	int i, status;
	u_int8_t r, g, b;
	visual_id_t vid = 0x00;
	atom_t mwm_hints_atom;
	char *host = NULL;
	char *fg_pix_str = NULL;
        char *bg_pix_str = NULL;
	char *def_font_name = NULL;
	visual_t *vis_ptr = NULL;
	depth_t depth = 0;

/*
visual_info_t vinfo;
visual_id_t vid;
 */

	/* Get pointer to gui connection structure. */
	gui = &osw_gui[0];

	/* Reset values. */
        gui->std_font = NULL;
	gui->bold_font = NULL;

        gui->display_width = 0;
        gui->display_height = 0;

        gui->black_pix = 0;
        gui->white_pix = 0;

        gui->std_cursor = 0;
        gui->root_win = 0;

        gui->current_font = NULL;
        gui->current_fg_pix = 0;
        gui->current_bg_pix = 0;
        gui->current_alpha_pix = 0;


        gui->def_font = NULL;
        gui->def_bg_pix = 0;
        gui->def_fg_pix = 0;
        gui->def_toplevel_x = 0;
        gui->def_toplevel_y = 0;
        gui->def_toplevel_width = 0;
        gui->def_toplevel_height = 0;
        gui->def_geometry_set = False;
#ifdef USE_XSHM
	gui->def_use_shm = True;
	gui->def_sync_shm = True;	/* Default to True, so mandatory syncing. */
#else
	gui->def_use_shm = False;
	gui->def_sync_shm = False;
#endif

        gui->vendor_id = NULL;
        gui->vendor_version = 0;
        gui->vendor_release_version = 0;


	osw_icon_record = NULL;
	osw_total_icon_records = 0;


	/* Parse arguments. */
	for(i = 0; i < argc; i++)
	{
	    if(argv[i] == NULL)
		continue;

	    /* Display. */
	    if(!strcmp(argv[i], "--display") ||
               !strcmp(argv[i], "--dpy") ||
               !strcmp(argv[i], "-display") ||
               !strcmp(argv[i], "-dpy")
	    )
	    {
		i++;
		if(i < argc)
		{
		    host = argv[i];
		}
		else
		{
		    fprintf(
			stderr,
			"%s: Requires argument.\n",
			argv[i - 1]
		    );
		}
	    }
	    /* Visual. */
            else if(!strcmp(argv[i], "--visual") ||
                    !strcmp(argv[i], "-visual")
	    )
	    {
                i++;
                if(i < argc)
                {
		    sscanf(argv[i], "%ld", &vid);
                }
                else
                {
                    fprintf(
                        stderr,
                        "%s: Requires argument.\n",
                        argv[i - 1]
                    );
                }
	    }
	    /* Depth. */
	    else if(!strcmp(argv[i], "--depth") ||
                    !strcmp(argv[i], "-depth")
            )
	    {
                i++;
                if(i < argc)
                {
		    depth = atoi(argv[i]);
                }
                else
                {
                    fprintf(
                        stderr,
                        "%s: Requires argument.\n",
                        argv[i - 1]
                    );
                }
            }
            /* Geometry. */
            else if(!strcmp(argv[i], "--geometry") ||
                    !strcmp(argv[i], "-geometry")
            )
            {
                i++;
                if(i < argc)
                {
                    XParseGeometry(argv[i],
                        &gui->def_toplevel_x,
                        &gui->def_toplevel_y,
                        &gui->def_toplevel_width,
                        &gui->def_toplevel_height
                    );
                    gui->def_geometry_set = True;
		}
		else
		{
                    fprintf(
                        stderr,
                        "%s: Requires argument.\n",
                        argv[i - 1]
                    );
		}
            }
            /* Default font (not the standard font). */
            else if(!strcmp(argv[i], "--font") ||
                    !strcmp(argv[i], "-font") ||
                    !strcmp(argv[i], "--fn") || 
                    !strcmp(argv[i], "-fn")
            )
            {
                i++;
                if(i < argc)
                {
		    def_font_name = argv[i];
                }
                else
                {
                    fprintf(
                        stderr,
                        "%s: Requires argument.\n",
                        argv[i - 1]
                    );
                }
            }
	    /* Background pixel. */
            else if(!strcmp(argv[i], "--background") ||
                    !strcmp(argv[i], "-background") ||
                    !strcmp(argv[i], "--bg") ||
                    !strcmp(argv[i], "-bg")
            )
            {
                i++;
                if(i < argc)
                {
		    bg_pix_str = argv[i];
                }
                else
                {
                    fprintf(
                        stderr,
                        "%s: Requires argument.\n",
                        argv[i - 1]
                    );
                }
            }           
            /* Foreground pixel. */
            else if(!strcmp(argv[i], "--foreground") ||
                    !strcmp(argv[i], "-foreground") ||
                    !strcmp(argv[i], "--fg") ||
                    !strcmp(argv[i], "-fg")      
            )
            {
                i++;
                if(i < argc)
                {
                    fg_pix_str = argv[i];
                }
                else
                {   
                    fprintf(
                        stderr,
                        "%s: Requires argument.\n",
                        argv[i - 1]
                    );
                }
            }
            /* No shared memory. */
            else if(!strcmp(argv[i], "--no_shm") ||
                    !strcmp(argv[i], "-no_shm") ||
                    !strcmp(argv[i], "--noshm") ||
                    !strcmp(argv[i], "-no_shm") ||
                    !strcmp(argv[i], "--no_xshm") ||
                    !strcmp(argv[i], "-no_xshm") ||
                    !strcmp(argv[i], "--noxshm") ||
                    !strcmp(argv[i], "-noxshm")
            )
	    {
		gui->def_use_shm = False;
	    }
            /* Auto sync shared memory puts. */
            else if(!strcmp(argv[i], "--sync_xshm") ||
                    !strcmp(argv[i], "-sync_xshm") ||
                    !strcmp(argv[i], "--sync_shm") ||
                    !strcmp(argv[i], "-sync_shm")
            )
            {
                gui->def_sync_shm = True;
            }
	}


        /* ********************************************************* */
	/* Open connection to display. */
	gui->display = XOpenDisplay(host);
        if(gui->display == NULL)
        {
            /* Print reason for failed connect. */
            fprintf(stderr, "Cannot connect to X server: ");
            if(getenv("DISPLAY") == NULL)
                fprintf(stderr, "`DISPLAY' environment variable not set.");
            else
                fprintf(stderr, "%s", XDisplayName(NULL));
            fprintf(stderr, "\n");

            /* Print verbose help. */
            fprintf(stderr,
"\nCheck to make sure that your X server is running and that your\n\
enviroment variable `DISPLAY' is set properly.\n"
            );

            return(1);
        }


        /* ********************************************************* */
        /* Get default values. */
        gui->scr_num = DefaultScreen(gui->display);
        gui->scr_ptr = DefaultScreenOfDisplay(gui->display);
        gui->visual = DefaultVisualOfScreen(gui->scr_ptr);
	gui->visual_id = XVisualIDFromVisual(gui->visual);

        gui->depth = (depth == 0) ?
	    DefaultDepthOfScreen(gui->scr_ptr) : depth;

/*
vinfo.depth = depth;
vinfo.class = TrueColor;
vptr = GETVISUALBYCRITERIA(
	VisualDepthMask | VisualClassMask,
	vinfo
);
if(vptr != NULL)
{
    vid = XVisualIDFromVisual(vptr);
    printf("Visual ID: 0x%.8x\n", vid);

    printf("0x%.8x 0x%.8x\n", vptr, visual);
}
*/

        gui->display_width = DisplayWidth(
	    gui->display,
	    gui->scr_num
	);
        gui->display_height = DisplayHeight(
	    gui->display,
	    gui->scr_num
	);

	gui->black_pix = BlackPixelOfScreen(gui->scr_ptr);
	gui->white_pix = WhitePixelOfScreen(gui->scr_ptr);

        gui->gc = DefaultGC(gui->display, gui->scr_num);

	gui->colormap = DefaultColormap(gui->display,
	    gui->scr_num);

	gui->std_cursor = OSWLoadBasicCursor(XC_left_ptr);
	gui->root_win = DefaultRootWindow(gui->display);


	/* Change visual? */
	if(vid != 0x00)
	{
	    vis_ptr = OSWGetVisualByID(vid);
	    if(vis_ptr == NULL)
	    {
		fprintf(stderr,
		    "Cannot obtain visual 0x%.2x.\n",
		    (int)vid
		);
	    }
	    else
	    {
	        gui->visual = vis_ptr;
	    }
	}

	gui->red_mask = gui->visual->red_mask;
        gui->green_mask = gui->visual->green_mask;
        gui->blue_mask = gui->visual->blue_mask;


        /* ********************************************************* */
        /* Default foreground and background pixels. */
	StringParseStdColor(
	    (bg_pix_str == NULL) ? "#000000" : bg_pix_str,
	    &r, &g, &b
	);
	OSWLoadPixelRGB(&gui->def_bg_pix, r, g, b);

        StringParseStdColor(
            (fg_pix_str == NULL) ? "#ffffff" : fg_pix_str,
            &r, &g, &b
        );
        OSWLoadPixelRGB(&gui->def_fg_pix, r, g, b);



        /* ********************************************************* */
	/* Load standard and default fonts. */

	/* Standard font. */
	status = OSWLoadFont(&gui->std_font, "7x14");
	if(status)
	    fprintf(stderr,
		"%s: Unable to load font.\n",
		"7x14"
	    );

	/* Standard bold font. */
	status = OSWLoadFont(&gui->bold_font, "7x14");
        if(status)
            fprintf(stderr,
                "%s: Unable to load font.\n",
                "7x14"
            );

	/* Default font (the one specified from command line -fn). */
	status = OSWLoadFont(
	    &gui->def_font,
	    (def_font_name == NULL) ? "7x14" : def_font_name
	);
        if(status)
            fprintf(stderr,
                "%s: Unable to load font.\n",
                (def_font_name == NULL) ? "7x14" : def_font_name
            );
	/* Load something incase of error. */
        if(gui->def_font == NULL)
            OSWLoadFont(&gui->def_font, "7x14");


        /* ********************************************************* */
	/* Set up default foreground values. */
	OSWSetFgPix(gui->white_pix);
        OSWSetFont(gui->std_font);


        /* ********************************************************* */
	/* Load key codes from OS's keysyms. */
	OSWLoadKeyCodes();


	/* ********************************************************* */
	/* Load property atoms (unique to X Window Systems). */

	/* Check if MWM is supported. */
        mwm_hints_atom = XInternAtom(
	    gui->display,
	    _XA_MWM_HINTS,
	    False
	);
        if(mwm_hints_atom == None)
	{
	    fprintf(stderr,
 "OSWGUIConnect(): Warning: Window manager does not support %s.\n",
		_XA_MWM_HINTS
	    );
        }



        /* Motif protocol$. */

        osw_atom._motif_wm_all_clients = XInternAtom(
            gui->display,
            "_MOTIF_WM_ALL_CLIENTS",
            False
        );

        osw_atom._motif_wm_hints = XInternAtom(
            gui->display,
            "_MOTIF_WM_HINTS",
            False
        );

        osw_atom._motif_wm_info = XInternAtom(
            gui->display,
            "_MOTIF_WM_INFO",
            False
        );

        osw_atom._motif_wm_menu = XInternAtom(
            gui->display,
            "_MOTIF_WM_MENU",
            False
        );

        osw_atom._motif_wm_messages = XInternAtom(
            gui->display,
            "_MOTIF_WM_MESSAGES",
            False
        );

        osw_atom._motif_wm_offset = XInternAtom(
            gui->display,
            "_MOTIF_WM_OFFSET",
            False
        );

        osw_atom._motif_wm_query = XInternAtom(
            gui->display,
            "_MOTIF_WM_QUERY",
            False
        );


        /* Standard management protocols. */
        osw_atom.wm_delete_window = XInternAtom(
            gui->display,
            "WM_DELETE_WINDOW",
            False
        );

        osw_atom.wm_protocols = XInternAtom(
            gui->display,
            "WM_PROTOCOLS",
            False
        );  

        osw_atom.wm_save_yourself = XInternAtom(
            gui->display,
            "WM_SAVE_YOURSELF",
            False
        );
        
        osw_atom.wm_state = XInternAtom(
            gui->display,
            "WM_STATE",
            False
        );

        osw_atom.wm_take_focus = XInternAtom(   
            gui->display,
            "WM_TAKE_FOCUS",
            False
        );


        /* Root stuff. */
        osw_atom._xrootpmap_id = XInternAtom(
            gui->display,
            "_XROOTPMAP_ID",   
            False
        );

        osw_atom._xrootcolor_pixel = XInternAtom(
            gui->display,
            "_XROOTCOLOR_PIXEL",
            False
        );

        /* Enlightenment WM Protocols. */
        osw_atom.enl_msg = XInternAtom( 
            gui->display,
            "_XROOTCOLOR_PIXEL",
            False
        );

        osw_atom.enlightenment_desktop = XInternAtom(
            gui->display,
            "ENLIGHTENMENT_DESKTOP",
            False
        );

        osw_atom.enlightenment_comms = XInternAtom(
            gui->display,
            "ENLIGHTENMENT_COMMS",
            False
        );


	/* ******************************************************* */

	/* Set error handler. */
	XSetErrorHandler(OSWXErrorHandler);


	return(0);
}



/*
 *	Disconnect from GUI.
 */
void OSWGUIDisconnect()
{
	int i;
        osw_gui_struct *gui;


	if(IDC())
	{
	    gui = &osw_gui[0];

	    /* Purge all events. */
	    OSWPurgeAllEvents();

	    /* Toplevel window WM icons. */
	    for(i = 0; i < osw_total_icon_records; i++)
	    {
		osw_icon_record[i].owner = 0;
/*
                OSWDestroyWindow(&osw_icon_record[i].w);
                OSWDestroyPixmap(&osw_icon_record[i].pixmap);
                OSWDestroyPixmap(&osw_icon_record[i].mask);
 */
	    }
	    free(osw_icon_record);
	    osw_total_icon_records = 0;


	    /* Free resources. */
	    OSWDestroyPixel(&gui->def_bg_pix);
	    OSWDestroyPixel(&gui->def_fg_pix);
	    OSWUnloadFont(&gui->def_font);

/*	    XFreeColormap(gui->display, gui->colormap); */

	    OSWUnloadFont(&gui->std_font);
	    OSWUnloadFont(&gui->bold_font);


	    /* Close connection to server. */
	    XSetCloseDownMode(gui->display, DestroyAll);
            XCloseDisplay(gui->display);


	    free(gui->vendor_id);
	    gui->vendor_id = NULL;

	    gui->def_use_shm = False;
            gui->def_geometry_set = False;
            gui->def_toplevel_width = 0;
            gui->def_toplevel_height = 0;
            gui->def_toplevel_x = 0;
            gui->def_toplevel_y = 0;

            gui->red_mask = 0;
            gui->green_mask = 0;
            gui->blue_mask = 0;

            gui->display_width = 0;
            gui->display_height = 0;
            gui->black_pix = 0;
            gui->white_pix = 0;
            gui->std_cursor = 0;
            gui->root_win = 0;
            gui->current_font = NULL;
            gui->current_fg_pix = 0;
            gui->current_bg_pix = 0;
            gui->current_alpha_pix = 0;

	    gui->alt_key_state = False;
            gui->ctrl_key_state = False;
            gui->shift_key_state = False;
            gui->caps_lock_on = False;
            gui->num_lock_on = False;
            gui->scroll_lock_on = False;

            gui->display = NULL;
            gui->scr_num = 0;
            gui->scr_ptr = NULL;
            gui->visual = NULL;
            gui->visual_id = 0;
            gui->depth = 0;

	    memset(&gui->colormap, 0x00, sizeof(colormap_t));
	    memset(&gui->gc, 0x00, sizeof(gc_t));
	}


	return;
}



/*
 *	Loads the OSW keycodes from the keysyms.
 */
int OSWLoadKeyCodes()
{
	display_t *d;


	if(!IDC())
	    return(-1);


	d = osw_gui[0].display;


	/*	Note: Rows reffer to the row count, top to bottom on
	 *	a US Qwerty keyboard.  Other keyboards may vary
	 *	however row is just use for programer comments.
	 */

	/* Row 1. */
	osw_keycode.esc = XKeysymToKeycode(d, XK_Escape);
        osw_keycode.f1 = XKeysymToKeycode(d, XK_F1);
        osw_keycode.f2 = XKeysymToKeycode(d, XK_F2);
        osw_keycode.f3 = XKeysymToKeycode(d, XK_F3);
        osw_keycode.f4 = XKeysymToKeycode(d, XK_F4);
        osw_keycode.f5 = XKeysymToKeycode(d, XK_F5);
        osw_keycode.f6 = XKeysymToKeycode(d, XK_F6);
        osw_keycode.f7 = XKeysymToKeycode(d, XK_F7);
        osw_keycode.f8 = XKeysymToKeycode(d, XK_F8);
        osw_keycode.f9 = XKeysymToKeycode(d, XK_F9);
        osw_keycode.f10 = XKeysymToKeycode(d, XK_F10);
        osw_keycode.f11 = XKeysymToKeycode(d, XK_F11);
        osw_keycode.f12 = XKeysymToKeycode(d, XK_F12);

        osw_keycode.f13 = XKeysymToKeycode(d, XK_F13);
        osw_keycode.f14 = XKeysymToKeycode(d, XK_F14);
        osw_keycode.f15 = XKeysymToKeycode(d, XK_F15);
        osw_keycode.f16 = XKeysymToKeycode(d, XK_F16);
        osw_keycode.f17 = XKeysymToKeycode(d, XK_F17);
        osw_keycode.f18 = XKeysymToKeycode(d, XK_F18);
        osw_keycode.f19 = XKeysymToKeycode(d, XK_F19);
        osw_keycode.f20 = XKeysymToKeycode(d, XK_F20);
        osw_keycode.f21 = XKeysymToKeycode(d, XK_F21);
        osw_keycode.f22 = XKeysymToKeycode(d, XK_F22);
        osw_keycode.f23 = XKeysymToKeycode(d, XK_F23);
        osw_keycode.f24 = XKeysymToKeycode(d, XK_F24);

        osw_keycode.f25 = XKeysymToKeycode(d, XK_F25);
        osw_keycode.f26 = XKeysymToKeycode(d, XK_F26);
        osw_keycode.f27 = XKeysymToKeycode(d, XK_F27);
        osw_keycode.f28 = XKeysymToKeycode(d, XK_F28);
        osw_keycode.f29 = XKeysymToKeycode(d, XK_F29);
        osw_keycode.f30 = XKeysymToKeycode(d, XK_F30);
        osw_keycode.f31 = XKeysymToKeycode(d, XK_F31);
        osw_keycode.f32 = XKeysymToKeycode(d, XK_F32);
        osw_keycode.f33 = XKeysymToKeycode(d, XK_F33);
        osw_keycode.f34 = XKeysymToKeycode(d, XK_F34);
        osw_keycode.f35 = XKeysymToKeycode(d, XK_F35);

	/* Row 2. */
/* XK_quotedbl */
        osw_keycode.tilde = XKeysymToKeycode(d, XK_asciitilde);
        osw_keycode.num_1 = XKeysymToKeycode(d, XK_1);
        osw_keycode.num_2 = XKeysymToKeycode(d, XK_2);
        osw_keycode.num_3 = XKeysymToKeycode(d, XK_3);
        osw_keycode.num_4 = XKeysymToKeycode(d, XK_4);
        osw_keycode.num_5 = XKeysymToKeycode(d, XK_5);
        osw_keycode.num_6 = XKeysymToKeycode(d, XK_6);
        osw_keycode.num_7 = XKeysymToKeycode(d, XK_7);
        osw_keycode.num_8 = XKeysymToKeycode(d, XK_8);
        osw_keycode.num_9 = XKeysymToKeycode(d, XK_9);
        osw_keycode.num_0 = XKeysymToKeycode(d, XK_0);

        osw_keycode.minus = XKeysymToKeycode(d, XK_minus);
        osw_keycode.equal = XKeysymToKeycode(d, XK_equal);
        osw_keycode.backslash = XKeysymToKeycode(d, XK_backslash);
        osw_keycode.backspace = XKeysymToKeycode(d, XK_BackSpace);

	/* Row 3. */
        osw_keycode.tab = XKeysymToKeycode(d, XK_Tab);
        osw_keycode.alpha_q = XKeysymToKeycode(d, XK_q);
        osw_keycode.alpha_w = XKeysymToKeycode(d, XK_w);
        osw_keycode.alpha_e = XKeysymToKeycode(d, XK_e);
        osw_keycode.alpha_r = XKeysymToKeycode(d, XK_r);
        osw_keycode.alpha_t = XKeysymToKeycode(d, XK_t);
        osw_keycode.alpha_y = XKeysymToKeycode(d, XK_y);
        osw_keycode.alpha_u = XKeysymToKeycode(d, XK_u);
        osw_keycode.alpha_i = XKeysymToKeycode(d, XK_i);
        osw_keycode.alpha_o = XKeysymToKeycode(d, XK_o);
        osw_keycode.alpha_p = XKeysymToKeycode(d, XK_p);
        osw_keycode.brace_left = XKeysymToKeycode(d, XK_braceleft);
        osw_keycode.brace_right = XKeysymToKeycode(d, XK_braceright);
        osw_keycode.enter = XKeysymToKeycode(d, XK_Return);

	/* Row 4. */
        osw_keycode.caps_lock = XKeysymToKeycode(d, XK_Caps_Lock);
        osw_keycode.alpha_a = XKeysymToKeycode(d, XK_a);
        osw_keycode.alpha_s = XKeysymToKeycode(d, XK_s);
        osw_keycode.alpha_d = XKeysymToKeycode(d, XK_d);
        osw_keycode.alpha_f = XKeysymToKeycode(d, XK_f);
        osw_keycode.alpha_g = XKeysymToKeycode(d, XK_g);
        osw_keycode.alpha_h = XKeysymToKeycode(d, XK_h);
        osw_keycode.alpha_j = XKeysymToKeycode(d, XK_j);
        osw_keycode.alpha_k = XKeysymToKeycode(d, XK_k);
        osw_keycode.alpha_l = XKeysymToKeycode(d, XK_l);
        osw_keycode.semicolon = XKeysymToKeycode(d, XK_semicolon);
        osw_keycode.quote = XKeysymToKeycode(d, XK_quoteright);
/* XK_quoteleft */

	/* Row 5. */
        osw_keycode.shift_left = XKeysymToKeycode(d, XK_Shift_L);
        osw_keycode.alpha_z = XKeysymToKeycode(d, XK_z);
        osw_keycode.alpha_x = XKeysymToKeycode(d, XK_x);
        osw_keycode.alpha_c = XKeysymToKeycode(d, XK_c);
        osw_keycode.alpha_v = XKeysymToKeycode(d, XK_v);
        osw_keycode.alpha_b = XKeysymToKeycode(d, XK_b);
        osw_keycode.alpha_n = XKeysymToKeycode(d, XK_n);
        osw_keycode.alpha_m = XKeysymToKeycode(d, XK_m);
        osw_keycode.comma = XKeysymToKeycode(d, XK_comma);
        osw_keycode.period = XKeysymToKeycode(d, XK_period);
        osw_keycode.slash = XKeysymToKeycode(d, XK_slash);
        osw_keycode.shift_right = XKeysymToKeycode(d, XK_Shift_R);

	/* Row 6. */
        osw_keycode.ctrl_left = XKeysymToKeycode(d, XK_Control_L);
        osw_keycode.alt_left = XKeysymToKeycode(d, XK_Alt_L);
        osw_keycode.win95_start = 0;
        osw_keycode.space = XKeysymToKeycode(d, XK_space);
        osw_keycode.alt_right = XKeysymToKeycode(d, XK_Alt_R);
        osw_keycode.ctrl_right = XKeysymToKeycode(d, XK_Control_R);


	/* Secondary section. */
        osw_keycode.print_screen = XKeysymToKeycode(d, XK_Sys_Req);
/* XK_3270_PrintScreen */
        osw_keycode.scroll_lock = XKeysymToKeycode(d, XK_Scroll_Lock);
        osw_keycode.pause = XKeysymToKeycode(d, XK_Pause);
        osw_keycode.insert = XKeysymToKeycode(d, XK_Insert);
        osw_keycode.home = XKeysymToKeycode(d, XK_Home);
        osw_keycode.page_up = XKeysymToKeycode(d, XK_Page_Up);
        osw_keycode.delete = XKeysymToKeycode(d, XK_Delete);
        osw_keycode.end = XKeysymToKeycode(d, XK_End);
        osw_keycode.page_down = XKeysymToKeycode(d, XK_Page_Down);
 
        osw_keycode.cursor_up = XKeysymToKeycode(d, XK_Up);
        osw_keycode.cursor_right = XKeysymToKeycode(d, XK_Right);
        osw_keycode.cursor_down = XKeysymToKeycode(d, XK_Down);
        osw_keycode.cursor_left = XKeysymToKeycode(d, XK_Left);

	/* Number pad. */
        osw_keycode.num_lock = XKeysymToKeycode(d, XK_Num_Lock);
        osw_keycode.np_slash = XKeysymToKeycode(d, XK_KP_Divide);
        osw_keycode.np_asterisk = XKeysymToKeycode(d, XK_KP_Multiply);
        osw_keycode.np_minus = XKeysymToKeycode(d, XK_KP_Subtract);
        osw_keycode.np_add = XKeysymToKeycode(d, XK_KP_Add);
        osw_keycode.np_enter = XKeysymToKeycode(d, XK_KP_Enter);
        osw_keycode.np_1 = XKeysymToKeycode(d, XK_KP_1);
        osw_keycode.np_2 = XKeysymToKeycode(d, XK_KP_2);
        osw_keycode.np_3 = XKeysymToKeycode(d, XK_KP_3);
        osw_keycode.np_4 = XKeysymToKeycode(d, XK_KP_4);
        osw_keycode.np_5 = XKeysymToKeycode(d, XK_KP_5);
        osw_keycode.np_6 = XKeysymToKeycode(d, XK_KP_6);
        osw_keycode.np_7 = XKeysymToKeycode(d, XK_KP_7);
        osw_keycode.np_8 = XKeysymToKeycode(d, XK_KP_8);
        osw_keycode.np_9 = XKeysymToKeycode(d, XK_KP_9);
        osw_keycode.np_0 = XKeysymToKeycode(d, XK_KP_0);
        osw_keycode.np_period = XKeysymToKeycode(d, XK_KP_Decimal);



	return(0);
}


/*
 *	This function is called internally to manage an event.
 *	Each event fetching function needs to call this function
 *	before returning the event to the calling function.
 */
void OSWManageEvent(event_t *event)
{
	osw_gui_struct *gui;
	keycode_t keycode;


	if(event == NULL)
	    return;

	gui = &osw_gui[0];


	switch(event->type)
	{
	  case KeyPress:
	    keycode = event->xkey.keycode;

	    if((keycode == osw_keycode.alt_left) ||
               (keycode == osw_keycode.alt_right)
	    )
		gui->alt_key_state = True;
	    else if((keycode == osw_keycode.ctrl_left) ||
                    (keycode == osw_keycode.ctrl_right)
            )
		gui->ctrl_key_state = True;
            else if((keycode == osw_keycode.shift_left) ||
                    (keycode == osw_keycode.shift_right)
            )
                gui->shift_key_state = True;

            else if(keycode == osw_keycode.caps_lock)
		gui->caps_lock_on = !gui->caps_lock_on;
            else if(keycode == osw_keycode.num_lock)
                gui->num_lock_on = !gui->num_lock_on;
            else if(keycode == osw_keycode.scroll_lock)
                gui->scroll_lock_on = !gui->scroll_lock_on;

	    break;


          case KeyRelease:
            keycode = event->xkey.keycode;

            if((keycode == osw_keycode.alt_left) ||
               (keycode == osw_keycode.alt_right)
            )
                gui->alt_key_state = False;
            else if((keycode == osw_keycode.ctrl_left) ||
                    (keycode == osw_keycode.ctrl_right)
            )
                gui->ctrl_key_state = False;
            else if((keycode == osw_keycode.shift_left) ||
                    (keycode == osw_keycode.shift_right)
            )
                gui->shift_key_state = False;

	    break;
	}


	return;
}


/*
 *	Returns an ASCII char from the givin keycode or '\0' if
 *	no match could be found.
 */
char OSWGetASCIIFromKeyCode(
	keycode_t keycode,
	bool_t shift,
	bool_t alt,
	bool_t ctrl
)
{
	/* Error checks. */
	if(keycode == 0)
	    return('\0');


	/* ******************************************************* */

	/* Row 1. */
	if(keycode == osw_keycode.esc)
	    return(0x1b);

	/* Row 2. */
	else if(keycode == osw_keycode.tilde)
	    return((shift) ? '~' : '`');

	else if(keycode == osw_keycode.num_1)
            return((shift) ? '!' : '1');

	else if(keycode == osw_keycode.num_2)
            return((shift) ? '@' : '2');

        else if(keycode == osw_keycode.num_3)
            return((shift) ? '#' : '3');

        else if(keycode == osw_keycode.num_4)
            return((shift) ? '$' : '4');

        else if(keycode == osw_keycode.num_5)
            return((shift) ? '%' : '5');

        else if(keycode == osw_keycode.num_6)
            return((shift) ? '^' : '6');

        else if(keycode == osw_keycode.num_7)
            return((shift) ? '&' : '7');

        else if(keycode == osw_keycode.num_8)
            return((shift) ? '*' : '8');

        else if(keycode == osw_keycode.num_9)
            return((shift) ? '(' : '9');

        else if(keycode == osw_keycode.num_0)
            return((shift) ? ')' : '0');

        else if(keycode == osw_keycode.minus)
            return((shift) ? '_' : '-');

        else if(keycode == osw_keycode.equal)
            return((shift) ? '+' : '=');

        else if(keycode == osw_keycode.backslash)
            return((shift) ? '|' : '\\');

        else if(keycode == osw_keycode.backspace)
            return('\b');


	/* *********************************************** */
	/* Row 3. */

        else if(keycode == osw_keycode.tab)
            return('\t');

        else if(keycode == osw_keycode.alpha_q)
            return((shift) ? 'Q' : 'q');

        else if(keycode == osw_keycode.alpha_w)
            return((shift) ? 'W' : 'w');

        else if(keycode == osw_keycode.alpha_e)
            return((shift) ? 'E' : 'e');

        else if(keycode == osw_keycode.alpha_r)
            return((shift) ? 'R' : 'r');

        else if(keycode == osw_keycode.alpha_t)
            return((shift) ? 'T' : 't');

        else if(keycode == osw_keycode.alpha_y)
            return((shift) ? 'Y' : 'y');

        else if(keycode == osw_keycode.alpha_u)
            return((shift) ? 'U' : 'u');

        else if(keycode == osw_keycode.alpha_i)
            return((shift) ? 'I' : 'i');

        else if(keycode == osw_keycode.alpha_o)
            return((shift) ? 'O' : 'o');

        else if(keycode == osw_keycode.alpha_p)
            return((shift) ? 'P' : 'p');

        else if(keycode == osw_keycode.brace_left)
            return((shift) ? '{' : '[');

        else if(keycode == osw_keycode.brace_right)
            return((shift) ? '}' : ']');

        else if(keycode == osw_keycode.enter)
            return((shift) ? '\n' : '\n');


	/* **************************************************** */
	/* Row 4. */
        else if(keycode == osw_keycode.alpha_a)
            return((shift) ? 'A' : 'a');

        else if(keycode == osw_keycode.alpha_s)
            return((shift) ? 'S' : 's');

        else if(keycode == osw_keycode.alpha_d)
            return((shift) ? 'D' : 'd');

        else if(keycode == osw_keycode.alpha_f)
            return((shift) ? 'F' : 'f');

        else if(keycode == osw_keycode.alpha_g)
            return((shift) ? 'G' : 'g');

        else if(keycode == osw_keycode.alpha_h)
            return((shift) ? 'H' : 'h');

        else if(keycode == osw_keycode.alpha_j)
            return((shift) ? 'J' : 'j');

        else if(keycode == osw_keycode.alpha_k)
            return((shift) ? 'K' : 'k');

        else if(keycode == osw_keycode.alpha_l)
            return((shift) ? 'L' : 'l');

        else if(keycode == osw_keycode.semicolon)
            return((shift) ? ':' : ';');

        else if(keycode == osw_keycode.quote)
            return((shift) ? '"' : '\'');


	/* ***************************************************** */
	/* Row 5. */

        else if(keycode == osw_keycode.alpha_z)
            return((shift) ? 'Z' : 'z');

        else if(keycode == osw_keycode.alpha_x)
            return((shift) ? 'X' : 'x');

        else if(keycode == osw_keycode.alpha_c)
            return((shift) ? 'C' : 'c');

        else if(keycode == osw_keycode.alpha_v)
            return((shift) ? 'V' : 'v');

        else if(keycode == osw_keycode.alpha_b)
            return((shift) ? 'B' : 'b');

        else if(keycode == osw_keycode.alpha_n)
            return((shift) ? 'N' : 'n');

        else if(keycode == osw_keycode.alpha_m)
            return((shift) ? 'M' : 'm');

        else if(keycode == osw_keycode.comma)
            return((shift) ? '<' : ',');
         
        else if(keycode == osw_keycode.period)
            return((shift) ? '>' : '.');

        else if(keycode == osw_keycode.slash)
            return((shift) ? '?' : '/');


	/* *************************************************** */
	/* Row 6. */

        else if(keycode == osw_keycode.space)
            return((shift) ? ' ' : ' ');


        /* *************************************************** */
        /* Navigator keys. */

	else if(keycode == osw_keycode.delete)
            return(0x04);


	/* *************************************************** */
	/* Number pad. */

        else if(keycode == osw_keycode.np_slash)
            return((shift) ? '/' : '/');

        else if(keycode == osw_keycode.np_asterisk)
            return((shift) ? '*' : '*');

        else if(keycode == osw_keycode.np_minus)
            return((shift) ? '-' : '-');

        else if(keycode == osw_keycode.np_add)
            return((shift) ? '+' : '+');

        else if(keycode == osw_keycode.np_enter)
	    return((shift) ? '\n' : '\n');

        else if(keycode == osw_keycode.np_1)
            return((shift) ? '1' : '1');

        else if(keycode == osw_keycode.np_2)
            return((shift) ? '2' : '2');

        else if(keycode == osw_keycode.np_3)
            return((shift) ? '3' : '3');

        else if(keycode == osw_keycode.np_4)
            return((shift) ? '4' : '4');

        else if(keycode == osw_keycode.np_5)
            return((shift) ? '5' : '5');

        else if(keycode == osw_keycode.np_6)
            return((shift) ? '6' : '6');

        else if(keycode == osw_keycode.np_7)
            return((shift) ? '7' : '7');

        else if(keycode == osw_keycode.np_8)
            return((shift) ? '8' : '8');

        else if(keycode == osw_keycode.np_9)
            return((shift) ? '9' : '9');

        else if(keycode == osw_keycode.np_0)
            return((shift) ? '0' : '0');

        else if(keycode == osw_keycode.np_period)
            return((shift) ? '.' : '.');

	else
	    return('\0');
}



/*
 *	Returns a statically allocated string containing the
 *	formal name for the givin keycode looked up in the keysyms
 *	listing from the hardware.
 *
 *	The return string will contain a (usually) lower case name
 *	of the keycode or "#123" if the key is undefined where 123
 *	is the keycode.
 *
 *	This function never returns NULL.
 */
char *OSWGetKeyCodeName(keycode_t keycode)
{
	keysym_t keysym;
	static char rtn_str[128];


	/* Return none if keycode is 0. */
	if(keycode == 0)
	{
	    return("#0");
	}

	keysym = XKeycodeToKeysym(osw_gui[0].display, keycode, 0);
	if(keysym == NoSymbol)
	{
	    sprintf(rtn_str, "#%i", keycode);
	    return(rtn_str);
	}

	/* ******************************************************* */
	/* Misc. */
	if(keysym == XK_BackSpace)
	{
	    return("backspace");
	}
        else if(keysym == XK_Tab)
        {
            return("tab");
        }
        else if(keysym == XK_Linefeed)            
        {
            return("linefeed");
        }   
        else if(keysym == XK_Clear)
        {
            return("clear");
        }   
        else if(keysym == XK_Return)
        {
            return("enter");
        }   
        else if(keysym == XK_Pause)
        {
            return("pause");
        }   
        else if(keysym == XK_Scroll_Lock)            
        {
            return("scroll lock");
        }   
        else if(keysym == XK_Sys_Req)            
        {
            return("system request");
        }   
        else if(keysym == XK_Escape)
        {
            return("escape");
        }   
        else if(keysym == XK_Delete)            
        {
            return("delete");
        }   
        else if(keysym == XK_Home)            
        {
            return("home");
        }   
        else if(keysym == XK_End)            
        {
            return("end");
        }   
        else if(keysym == XK_Page_Up)            
        {
            return("page up");
        }   
        else if(keysym == XK_Page_Down)
        {
            return("page down");
        }   
        else if(keysym == XK_Up)
        {
            return("up");
        }   
        else if(keysym == XK_Down)            
        {
            return("down");
        }   
        else if(keysym == XK_Left)            
        {
            return("left");
        }   
        else if(keysym == XK_Right)
        {
            return("right");
        }   
        else if(keysym == XK_Insert)            
        {
            return("insert");
        }   
        else if(keysym == XK_Break)            
        {
            return("break");
        }   
        else if(keysym == XK_Num_Lock)            
        {
            return("num lock");
        }   

	/* ****************************************************** */
	/* Number pad keys. */
        else if(keysym == XK_KP_Space)
        {
            return("np space");
        }
        else if(keysym == XK_KP_Tab)
        {
            return("np tab");
        }
        else if(keysym == XK_KP_Enter)            
        {
            return("np enter");
        }   
        else if(keysym == XK_KP_Home)
        {
            return("np home");
        }   
        else if(keysym == XK_KP_End)            
        {
            return("np end");
        }   
        else if(keysym == XK_KP_Page_Up)            
        {
            return("np page up");
        }   
        else if(keysym == XK_KP_Page_Down)
        {
            return("np page down");
        }   
        else if(keysym == XK_KP_Up)       
        {
            return("np up");
        }   
        else if(keysym == XK_KP_Down)            
        {
            return("np down");
        }   
        else if(keysym == XK_KP_Left)            
        {
            return("np left");
        }   
        else if(keysym == XK_KP_Right)
        {
            return("np right");
        }
        else if(keysym == XK_KP_Insert)
        {
            return("np insert");
        }   
        else if(keysym == XK_KP_Delete)
        {
            return("np delete");
        }   
        else if(keysym == XK_KP_Equal)          
        {
            return("np equal");
        }   
        else if(keysym == XK_KP_Multiply)
        {
            return("np multiply");
        }   
        else if(keysym == XK_KP_Divide)
        {
            return("np divide");
        }
        else if(keysym == XK_KP_Add)
        {
            return("np add");
        }
        else if(keysym == XK_KP_Subtract)
        {
            return("np subtract");
        }
        else if(keysym == XK_KP_Decimal)
        {
            return("np decimal");
        }
        else if(keysym == XK_KP_0)
        {
            return("np 0");
        }
        else if(keysym == XK_KP_1)
        {
            return("np 1");
        }
        else if(keysym == XK_KP_2)
        {
            return("np 2");
        }
        else if(keysym == XK_KP_3)
        {
            return("np 3");
        }
        else if(keysym == XK_KP_4)
        {
            return("np 4");
        }
        else if(keysym == XK_KP_5)
        {
            return("np 5");
        }
        else if(keysym == XK_KP_6)
        {
            return("np 6");
        }
        else if(keysym == XK_KP_7)
        {
            return("np 7");
        }
        else if(keysym == XK_KP_8)
        {
            return("np 8");
        }
        else if(keysym == XK_KP_9)
        {
            return("np 9");
        }

	/* Function keys. */
        else if(keysym == XK_F1)
        {
            return("f1");
        }
        else if(keysym == XK_F2)
        {
            return("f2");
        }
        else if(keysym == XK_F3)
        {
            return("f3");
        }
        else if(keysym == XK_F4)
        {
            return("f4");
        }
        else if(keysym == XK_F5)
        {
            return("f5");
        }
        else if(keysym == XK_F6)
        {
            return("f6");
        }
        else if(keysym == XK_F7)
        {
            return("f7");
        }
        else if(keysym == XK_F8)
        {
            return("f8");
        }
        else if(keysym == XK_F9)
        {
            return("f9");
        }
        else if(keysym == XK_F10)
        {
            return("f10");
        }
        else if(keysym == XK_F11)
        {
            return("f11");
        }
        else if(keysym == XK_F12)
        {
            return("f12");
        }
        else if(keysym == XK_F13)
        {
            return("f13");
        }
        else if(keysym == XK_F14)
        {
            return("f14");
        }
        else if(keysym == XK_F15)
        {
            return("f15");
        }
        else if(keysym == XK_F16)
        {
            return("f16");
        }
        else if(keysym == XK_F17)
        {
            return("f17");
        }
        else if(keysym == XK_F18)
        {
            return("f18");
        }
        else if(keysym == XK_F19)
        {
            return("f19");
        }
        else if(keysym == XK_F20)
        {
            return("f20");
        }
        else if(keysym == XK_F21)
        {
            return("f21");
        }
        else if(keysym == XK_F22)
        {
            return("f22");
        }
        else if(keysym == XK_F23)
        {
            return("f23");
        }
        else if(keysym == XK_F24)
        {
            return("f24");
        }
        else if(keysym == XK_F25)
        {
            return("f25");
        }
        else if(keysym == XK_F26)
        {
            return("f26");
        }
        else if(keysym == XK_F27)
        {
            return("f27");
        }
        else if(keysym == XK_F28)
        {
            return("f28");
        }
        else if(keysym == XK_F29)
        {
            return("f29");
        }
        else if(keysym == XK_F30)
        {
            return("f30");
        }
        else if(keysym == XK_F31)
        {
            return("f31");
        }   
        else if(keysym == XK_F32)
        {
            return("f32");
        }
        else if(keysym == XK_F33)
        {
            return("f33");
        }
        else if(keysym == XK_F34)
        {
            return("f34");
        }
        else if(keysym == XK_F35)
        {
            return("f35");
        }

	/* Modifiers */
        else if(keysym == XK_Shift_L)
        {
            return("shift left");
        }   
        else if(keysym == XK_Shift_R)
        {
            return("shift right");
        }   
        else if(keysym == XK_Control_L)
        {
            return("control left");
        }   
        else if(keysym == XK_Control_R)
        {
            return("control right");
        }   
        else if(keysym == XK_Caps_Lock)
        {
            return("caps lock");
        }   
        else if(keysym == XK_Alt_L)
        {
            return("alt left");
        }   
        else if(keysym == XK_Alt_R)
        {
            return("alt right");
        }

	/* Latin 1 keys. */
        else if(keysym == XK_space)
        {
            return("space");
        }   
        else if(keysym == XK_minus)
        {
            return("minus");
        }   
        else if(keysym == XK_equal)
        {
            return("equal");
        }   
        else if(keysym == XK_backslash)
        {
            return("back slash");
        }   
        else if(keysym == XK_quoteleft)
        {
            return("quote left");
        }   
        else if(keysym == XK_0)
        {
            return("0");
        }   
        else if(keysym == XK_1)
        {
            return("1");
        }   
        else if(keysym == XK_2)
        {
            return("2");
        }   
        else if(keysym == XK_3)
        {
            return("3");
        }   
        else if(keysym == XK_4)
        {
            return("4");
        }
        else if(keysym == XK_5)
        {
            return("5");
        }
        else if(keysym == XK_6)
        {
            return("6");
        }
        else if(keysym == XK_7)
        {
            return("7");
        }
        else if(keysym == XK_8)
        {
            return("8");
        }
        else if(keysym == XK_9)
        {
            return("9");
        }
        else if(keysym == XK_a)
        {
            return("a");
        }
        else if(keysym == XK_b)
        {
            return("b");
        }
        else if(keysym == XK_c)
        {
            return("c");
        }
        else if(keysym == XK_d)
        {
            return("d");
        }
        else if(keysym == XK_e)
        {
            return("e");
        }
        else if(keysym == XK_f)
        {
            return("f");
        }
        else if(keysym == XK_g)
        {
            return("g");
        }
        else if(keysym == XK_h)
        {
            return("h");
        }
        else if(keysym == XK_i)
        {
            return("i");
        }
        else if(keysym == XK_j)
        {
            return("j");
        }
        else if(keysym == XK_k)
        {
            return("k");
        }
        else if(keysym == XK_l)
        {
            return("l");
        }
        else if(keysym == XK_m)
        {
            return("m");
        }
        else if(keysym == XK_n)
        {
            return("n");
        }
        else if(keysym == XK_o)
        {
            return("o");
        }
        else if(keysym == XK_p)
        {
            return("p");
        }
        else if(keysym == XK_q)
        {
            return("q");
        }
        else if(keysym == XK_r)
        {
            return("r");
        }
        else if(keysym == XK_s)
        {
            return("s");
        }
        else if(keysym == XK_t)
        {
            return("t");
        }
        else if(keysym == XK_u)
        {
            return("u");
        }
        else if(keysym == XK_v)
        {
            return("v");
        }
        else if(keysym == XK_w)
        {
            return("w");
        }
        else if(keysym == XK_x)
        {
            return("x");
        }
        else if(keysym == XK_y)
        {
            return("y");
        }
        else if(keysym == XK_z)
        {
            return("z");
        }
        else if(keysym == XK_bracketleft)
        {
            return("bracket left");
        }
        else if(keysym == XK_bracketright)
        {
            return("bracket right");
        }
        else if(keysym == XK_braceleft)
        {
            return("brace left");
        }
        else if(keysym == XK_braceright)
        {
            return("brace right");
        }
        else if(keysym == XK_semicolon)
        {
            return("semicolon");
        }
        else if(keysym == XK_quoteright)
        {
            return("quote right");
        }
        else if(keysym == XK_comma)
        {
            return("comma");
        }
        else if(keysym == XK_period)
        {
            return("period");
        }
        else if(keysym == XK_slash)
        {
            return("slash");
        }


        sprintf(rtn_str, "#%i", keycode);
        return(rtn_str);
}



/*
 *	Flush events and sync with GUI.
 */
void OSWGUISync(bool_t discard)
{
	if(!IDC())
	    return;

	XSync(osw_gui[0].display, discard);

	return;
}


/*
 *	Get pointer coordinates.
 */
void OSWGetPointerCoords(
        win_t w,
        int *root_x, int *root_y,
        int *wx, int *wy
)
{
        static win_t root_return, child_return;
        static int root_x_return, root_y_return;
        static int win_x_return, win_y_return;
        static unsigned int mask_return;

        if(root_x != NULL)
            *root_x = 0;  
        if(root_y != NULL)
            *root_y = 0;
            
        if(wx != NULL)
            *wx = 0;
        if(wy != NULL)
            *wy = 0;


        if(!IDC() ||
           (w == 0)
        )
            return;

        XQueryPointer(
            osw_gui[0].display,
            w, 
            &root_return,
            &child_return,
            &root_x_return, &root_y_return,
            &win_x_return, &win_y_return,
            &mask_return
        );

        if(root_x != NULL)
            *root_x = root_x_return;
        if(root_y != NULL)
            *root_y = root_y_return;
  
        if(wx != NULL)
            *wx = win_x_return;
        if(wy != NULL)
            *wy = win_y_return;


        return;
}

/*
 *	Checks if the keycode is a modifier key.
 *
 *	Modifier keys are considered as follows:
 *
 *	alt, ctrl, and shift
 *
 *	Warning, Return may be incorrect if not connected to GUI.
 */
int OSWIsModifierKey(keycode_t keycode)
{
	if((keycode == osw_keycode.alt_left) ||
           (keycode == osw_keycode.alt_right) ||
           (keycode == osw_keycode.ctrl_left) ||
           (keycode == osw_keycode.ctrl_right) ||
           (keycode == osw_keycode.shift_left) ||
           (keycode == osw_keycode.shift_right)
	)
	    return(1);
	else
	    return(0);
}


/*
 *	Grabs the pointer in respect to grab_w and confined to window
 *	confine_w.
 *
 *	owner_events indicates whether the pointer events are to
 *	be reported as usual or reported with respect to the
 *	grab_w window if selected by the event mask.
 */
int OSWGrabPointer(
	win_t grab_w,
	bool_t events_rel_grab_w,
	eventmask_t eventmask,
	int pointer_mode,	/* GrabModeSync or GrabModeAsync. */
	int keyboard_mode,	/* GrabModeSync or GrabModeAsync. */
	win_t confine_w,	/* Can be None. */
	cursor_t cursor 	/* Can be None. */
)
{

	if(!IDC() ||
           (grab_w == 0)
	)
	    return(!GrabSuccess);

	return(
	    XGrabPointer(
		osw_gui[0].display,
		grab_w,
		!events_rel_grab_w,
		eventmask,
		pointer_mode,
		keyboard_mode,
		confine_w,
		cursor,
		CurrentTime
	    )
	);
}


/*
 *	Ungrabs the pointer.
 */
void OSWUngrabPointer()
{
	if(!IDC())
	    return;

	XUngrabPointer(osw_gui[0].display, CurrentTime);


	return;
}


/*
 *	Frees GUI allocated resource.  Memory allocated by GUI
 *	should be free'ed by a call to this general-purpose function.
 */
void OSWGUIFree(void **ptr)
{
	if(!IDC() ||
           (ptr == NULL)
	)
	    return;

	if(*ptr != NULL)
	{
	    XFree(*ptr);
	    *ptr = NULL;
	}

	return;
}



/*
 *	Fetch (get) contents of dynamic data exchange buffer.
 */
void *OSWFetchDDE(int *bytes)
{
	void *ptr;

	if(!IDC() ||
           (bytes == NULL)
	)
	    return(NULL);

	ptr = (void *)XFetchBytes(osw_gui[0].display, bytes);
	if(ptr == NULL)
	{
	    *bytes = 0;
	}

	return(ptr);
}



/*
 *	Put (store) dynamic data exchange buffer.
 */
void OSWPutDDE(void *buf, int bytes)
{
        if(!IDC() ||
           (buf == NULL) ||
           (bytes <= 0)
        )
            return;

	XStoreBytes(osw_gui[0].display, (char *)buf, bytes);

	return;
}



/*
 *      Returns a visual pointer by a match givin in the criteria
 *      for a visual info. 
 */
visual_t *OSWGetVisualByCriteria(
        visual_info_mask_t vinfo_mask,
        visual_info_t criteria_vinfo
)
{               
        int num_rtn;
        visual_info_t *vinfo_rtn;
        visual_t *visual_rtn;
   

        if(!IDC())
            return(NULL);

        vinfo_rtn = XGetVisualInfo(
            osw_gui[0].display,
            vinfo_mask,
            &criteria_vinfo,
            &num_rtn
        );

        if((num_rtn <= 0) || (vinfo_rtn == NULL))
            return(NULL);


        /* Got match. */
        visual_rtn = vinfo_rtn->visual;

	/* Need to free the vinfo return. */        
        XFree(vinfo_rtn);


	/* Return the visual pointer. */
        return(visual_rtn);
}           



visual_t *OSWGetVisualByID(visual_id_t vid)
{
	int x;
	visual_info_t vinfo_ref;
	visual_info_t *vinfo_rtn;
	visual_t *vptr;


	if(!IDC())
	    return(NULL);


	vinfo_ref.visualid = vid;
	vinfo_rtn = XGetVisualInfo(
	    osw_gui[0].display,
	    VisualIDMask,
	    &vinfo_ref,
	    &x
	);
	if(vinfo_rtn == NULL)
	    return(NULL);

	/* Get visual pointer. */
	vptr = vinfo_rtn->visual;

	/* Free visual info return. */
	XFree(vinfo_rtn);
	vinfo_rtn = NULL;


	return(vptr);
}



/*
 *	Turns keyboard autorepeat off.
 */
void OSWKBAutoRepeatOff()
{
	if(!IDC())
	    return;

	XAutoRepeatOff(osw_gui[0].display);

	return;
}


/*
 *      Turns keyboard autorepeat on.
 */
void OSWKBAutoRepeatOn()
{
        if(!IDC())
            return;

        XAutoRepeatOn(osw_gui[0].display);

        return;
}



/*
 *	Load font.
 */
int OSWLoadFont(font_t **font, char *fontname)
{
	if(!IDC() ||
           (fontname == NULL) ||
           (font == NULL)
	)
	    return(-1);


	/* Allocate structure for GUI. */
	*font = (font_t *)calloc(1, sizeof(font_t));
	if(*font == NULL)
	    return(-1);


	/* Load the font. */
	(*font)->actual = XLoadQueryFont(osw_gui[0].display, fontname);
	if((*font)->actual == NULL)
	{
	    /* Load failure, free structure for GUI. */
	    free(*font);
	    *font = NULL;

	    return(-1);
	}
	else
	{
            (*font)->char_width = 0;
            (*font)->char_height = 0;
            (*font)->total_chars = (*font)->actual->n_properties;

	    return(0);
	}
}


/*
 *	Returns the current font pointer set in the graphics
 *	context foreground or NULL on error.
 */
font_t *OSWQueryCurrentFont()
{
	return(osw_gui[0].current_font);
}


/*
 *	Set font for the graphics context foreground.
 */
void OSWSetFont(font_t *font)
{
	if(!IDC() ||
           (font == NULL)
	)
	    return;
	if(font->actual == NULL)
	    return;

	/* No change in font pointers? */
	if(font == osw_gui[0].current_font)
	    return;

	/* Set new font. */
	XSetFont(
	    osw_gui[0].display,
	    osw_gui[0].gc,
	    font->actual->fid
	);

	/* Record current font. */
	osw_gui[0].current_font = font;


	return;
}


/*
 *	Unload font.
 */
void OSWUnloadFont(font_t **font)
{
        if(!IDC() ||
           (font == NULL)
        )
            return;
	if(*font == NULL)
	    return;


	/* Unset current_font as needed. */
	if(*font == osw_gui[0].current_font)
	{
	    osw_gui[0].current_font = NULL;
	}


	/* Unload font. */
	if((*font)->actual != NULL)
	{
	    XFreeFont(
		osw_gui[0].display,
		(*font)->actual
	    );

	    (*font)->actual = NULL;
	}

	/* Free GUI's structure. */
	free(*font);
	*font = NULL;


	return;
}


/*
 *	Load a color pixel by RGB values.
 *
 *	Valid values for r, g, and b range from 0 to 255.
 *
 *      Returns 0 on success, -1 on general error, and -2 on
 *      ambiguous or missing data.
 */
int OSWLoadPixelRGB(
	pixel_t *pix_rtn,
	u_int8_t r,
	u_int8_t g,
	u_int8_t b
)
{
        static XColor c;


        if(pix_rtn == NULL)
            return(-1);

        if(!IDC())
        {
            *pix_rtn = 0;
            return(-1);
        }

        /* Set colors to be allocated. */
	c.flags = DoRed | DoGreen | DoBlue;
        c.red = ((u_int16_t)r << 8);
        c.green = ((u_int16_t)g << 8);
        c.blue = ((u_int16_t)b << 8);

        /* Allocate color. */
        if(XAllocColor(osw_gui[0].display, osw_gui[0].colormap, &c))
        {
            /* True, successful pixel allocation. */
            *pix_rtn = c.pixel;
            return(0);
        }

        /* False, failed allocation, use global black_pix. */
        *pix_rtn = osw_gui[0].black_pix;


        return(-1);
}


/*
 *      Load a color pixel by HSL values.
 *
 *      Valid values for h, s, and l range from 0 to 255.
 * 
 *      Returns 0 on success, -1 on general error, an\nd -2 on
 *      ambiguous or missing data.
 */
int OSWLoadPixelHSL(
	pixel_t *pix_rtn,
	u_int8_t h,
	u_int8_t s,
	u_int8_t l 
)
{


        return(-1);
}



/*
 *	Load pixel by given color specification string (CLSP).
 *	Returns zero on success, -1 on
 *
 *	The format for clsp is "rgbi:%lf/%lf/%lf".
 *	(The input format for clsp is native to Xlib.)
 *
 *	Returns 0 on success, -1 on general error, an\nd -2 on
 *	ambiguous or missing data.
 */
int OSWLoadPixelCLSP(pixel_t *pix_rtn, char *clsp)
{
	static XColor c;


	if(pix_rtn == NULL)
	    return(-1);

	if(!IDC() ||
           (clsp == NULL)
	)
	{
	    *pix_rtn = 0;
	    return(-1);
	}


	switch(
	    XParseColor(
		osw_gui[0].display,
		osw_gui[0].colormap,
		clsp,
		&c
	    )
	)
	{
	  case BadColor:
            fprintf(stderr,
                "OSWLoadPixelCLSP(): %s: BadColor\n",
                clsp
            );
	    *pix_rtn = 0;
	    return(-1);
            break;

	  case BadValue:
            fprintf(stderr,
                "OSWLoadPixelCLSP(): %s: BadValue\n",
                clsp
            );
	    *pix_rtn = 0;
	    return(-1);
            break;

	  default:
            if(XAllocColor(osw_gui[0].display, osw_gui[0].colormap, &c))
            {
		/* True, successful pixel allocation. */
                *pix_rtn = c.pixel;
                return(0);
            }
	    else
	    {
		/* False, failed allocation, use global black_pix. */
		*pix_rtn = osw_gui[0].black_pix;
		return(-1);
	    }
	    break;
	}

	return(0);
}



/*
 *	Set foreground pixel.
 */
void OSWSetFgPix(pixel_t pix)
{
        if(!IDC())
	    return;

	XSetForeground(osw_gui[0].display, osw_gui[0].gc, pix);

	/* Record current fg pixel. */
	osw_gui[0].current_fg_pix = pix;


	return;
}



/*
 *	Deallocates a loaded pixel.
 */
void OSWDestroyPixel(pixel_t *pix_ptr)
{
	if(!IDC() ||
           (pix_ptr == NULL)
	)
	    return;


	/* Leave default black and white pixels alone. */
	if((*pix_ptr == osw_gui[0].black_pix) ||
           (*pix_ptr == osw_gui[0].white_pix)
	)
	    return;

	/* Unset current pixel as needed. */
	if(osw_gui[0].current_fg_pix == *pix_ptr)
	    osw_gui[0].current_fg_pix = 0;


	/* Free pixel. */
	if(*pix_ptr != 0)
	{
            XFreeColors(
		osw_gui[0].display,
		osw_gui[0].colormap,
		pix_ptr,	/* Pixel array. */
		1,		/* Number of pixels. */
		0		/* Planes */
	    );

	    /* Reset pixel value to 0. */
	    *pix_ptr = 0;
	}


	return;
}


/*
 *	Load basic cursor.
 */
cursor_t OSWLoadBasicCursor(cur_code_t code)
{
	if(!IDC())
	    return(0);

	return(XCreateFontCursor(osw_gui[0].display, code));
}



/*
 *      Set cursor to window.
 */
void OSWSetWindowCursor(win_t w, cursor_t cursor)
{
        if(!IDC() ||
           (w == 0) ||
	   (cursor == 0)
	)
            return;

	XDefineCursor(osw_gui[0].display, w, cursor);

        return;
}



/*
 *	Destroy a cursor.
 */
void OSWDestroyCursor(cursor_t *cursor)
{
        if(!IDC() ||
	   (cursor == NULL)
	)
            return;

	if(*cursor != 0)
	{
	    XFreeCursor(osw_gui[0].display, *cursor);
	    *cursor = 0;
	}

	return;
}



/*
 *	Check events.
 */
int OSWEventsPending()
{
	if(!IDC())
	    return(0);

	return(XPending(osw_gui[0].display));
}


/*
 *	Block execution untill next event is recieved.
 *	Recieved event will be placed at the address of event.
 */
void OSWWaitNextEvent(event_t *event)
{
	if(event == NULL)
	    return;
	else
	    memset(event, 0x00, sizeof(event_t));

        if(!IDC())
	    return;

	XNextEvent(osw_gui[0].display, event);
	OSWManageEvent(event);

	return;
}


/*
 *      Block execution untill next event is recieved.      
 *      Recieved event will be coppied to the address of event,
 *	it will not be removed from the queue.
 */
void OSWWaitPeakEvent(event_t *event)
{
        if(event == NULL)
            return;
	else
	    memset(event, 0x00, sizeof(event_t));

        if(!IDC())
	    return;

        XPeekEvent(osw_gui[0].display, event);
	OSWManageEvent(event);

        return;
}


/*
 *	Checks the event queue for an event type matching the
 *	specified eventmask.
 *
 *	If an event is found, it will be removed from the queue
 *	and coppied to the event, returning True.
 *	If no event is found, then False is returned.
 */
bool_t OSWCheckMaskEvent(eventmask_t eventmask, event_t *event)
{
	bool_t status;


	if(!IDC() ||
           (event == NULL)
        )
	    return(False);


	status = XCheckMaskEvent(
            osw_gui[0].display,
            eventmask,
            event
        );
	if(status)
	    OSWManageEvent(event);

	return(status);
}       


/*
 *	The OSWWaitWindowEvent function searches the event queue for an event
 *	that matches both the specified window and event mask.  When it finds a
 *      match, OSWWaitWindowEvent removes that event from the queue and copies
 *	it into the specified event_t structure.  The other events stored in
 *	the queue are not discarded.  If a matching event is not in the queue,
 *	OSWWaitWindowEvent flushes the output buffer and blocks until one is
 *	received.
 */
void OSWWaitWindowEvent(win_t w, eventmask_t event_mask, event_t *event)
{
        if(event == NULL)
            return;
        else
            memset(event, 0x00, sizeof(event_t));

        if(!IDC() ||
           (w == 0)
	)
            return;

	XWindowEvent(osw_gui[0].display, w, event_mask, event);
	OSWManageEvent(event);

	return;
}



/*
 *	Checks event matching event_mask on window w.
 *	Returns True if matched event is found.
 */
bool_t OSWCheckWindowEvent(win_t w, eventmask_t event_mask, event_t *event)
{
	bool_t status;


        if(event == NULL)
            return(False);
        else
            memset(event, 0x00, sizeof(event_t));
       
        if(!IDC() ||
           (w == 0)
	)
            return(False);
 
	status = XCheckWindowEvent(
	    osw_gui[0].display,
	    w,
	    event_mask,
	    event
	);
	if(status)
	    OSWManageEvent(event);

	return(status);
} 


/*
 *	Puts the given event which was fetched earlier back onto
 *	the queue.   The given event should have been originally
 *	fetched from one of the event recieving functions and not
 *	just `made up'.
 */
void OSWPutBackEvent(event_t *event)
{
	if(!IDC() ||
           (event == NULL)
	)
	    return;

	XPutBackEvent(
	    osw_gui[0].display,
	    event
	);

	return;
}


/*
 *	Sends an event to the GUI, which can then be recieved by
 *	any of the event fetching functions.
 *
 *	Event members xany.window and type needs to be specified
 *	properly in the event_t structure.
 */
int OSWSendEvent(
	eventmask_t mask,
	event_t *event,
	bool_t propagate
)
{
	int status;


	if(!IDC() ||
           (event == NULL)
	)
	    return(-1);

	if(event->xany.window == 0)
	    return(-1);

	status = XSendEvent(
	    osw_gui[0].display,
	    event->xany.window,
	    propagate,
	    mask,
	    event
	);

	if(status)
	    return(0);
	else
	    return(-1);
}



/*
 *	Purges all events (if any) in the queue.
 */
int OSWPurgeAllEvents()
{
	event_t event;
	int i = 0;


        if(!IDC())
	    return(i);

	while(OSWEventsPending() > 0)
	{
	    OSWWaitNextEvent(&event);
	    i++;
	}

        return(i);
}


/*
 *	Removes all MotionNotify events except the most
 *	recent one.
 */
int OSWPurgeOldMotionEvents()
{
	event_t event;
	int i = 0;


	if(!IDC())
	    return(i);


        while(XCheckTypedEvent(osw_gui[0].display, MotionNotify, &event))
        {
            i++;
        }

	/* Put the last MotionNotify event back if there was one. */
	if(i > 0)
	{
	    XPutBackEvent(osw_gui[0].display, &event);
	}


	return(i);
}


/*
 *	Purges event table only of events matching event_type.
 */
int OSWPurgeTypedEvent(int event_type)
{
        event_t event;
	int i = 0;


	if(!IDC())
	    return(i);

	while(XCheckTypedEvent(osw_gui[0].display, event_type, &event))
	{
	    i++;
	}

	return(i);
}



/*      
 *      Purges event table only of events matching event_type and
 *	is for window w.
 */
int OSWPurgeWindowTypedEvent(win_t w, eventtype_t event_type)
{
        event_t event;
        int i = 0;  


        if(!IDC() || (w == 0))
            return(i);
 
        while(XCheckTypedWindowEvent(osw_gui[0].display, w, event_type, &event))
        {
            i++;
        }

        return(i);
}


/*
 *	Checks if event is a request to destroy window w.
 */
int OSWIsEventDestroyWindow(win_t w, event_t *event)
{
        if(!IDC() ||
           (w == 0) ||
           (event == NULL)
        )
            return(0);
 

        if((event->xclient.format == 32) &&
           (event->xclient.data.l[0] == osw_atom.wm_delete_window) &&
           (event->xany.window == w)
        )
            return(1);
        else
            return(0);
}



/*
 *	Create a window.
 */
int OSWCreateWindow(
        win_t *w,
        win_t parent,  
        int x, int y,
        unsigned int width, unsigned int height
)
{
	atom_t atom[10];
        XSetWindowAttributes swattr;


	if(!IDC() ||
           (w == NULL) ||
           (parent == 0) ||
           (width == 0) ||
           (height == 0)
	)
	    return(-1);


        /* Set up the window attributes. */
        memset(&swattr, 0x00, sizeof(XSetWindowAttributes));

	swattr.background_pixmap = ParentRelative;
        swattr.background_pixel = osw_gui[0].black_pix;
        swattr.border_pixel = osw_gui[0].white_pix;
        swattr.bit_gravity = CenterGravity;
        swattr.win_gravity = StaticGravity;
        swattr.backing_store = WhenMapped;	/* NotUseful, WhenMapped, Always */
        swattr.backing_planes = AllPlanes;
        swattr.backing_pixel = osw_gui[0].black_pix;
        swattr.save_under = False;
	swattr.event_mask = 0;
	swattr.do_not_propagate_mask = 0;
	swattr.override_redirect = False;
        swattr.colormap = CopyFromParent;
        swattr.cursor = osw_gui[0].std_cursor;


        /* Create Window. */
        *w = XCreateWindow(
            osw_gui[0].display,
            parent,
            x, y,
            width, height,
            0,			/* Border (internal, we don't want it). */
            osw_gui[0].depth,	/* Bit depth. */
            InputOutput,	/* InputOutput or InputOnly? */
            osw_gui[0].visual,	/* Should we use CopyFromParent? */
            OSW_WIN_ATTR_SET_MASK,	/* Set attributes mask. */
            &swattr		/* Set attributes. */
        );
        if(*w == 0)
            return(-1);

	/* If the parent is root_win, set wm_delete_window property atom. */
	if(parent == osw_gui[0].root_win)
	{
	    atom[0] = osw_atom.wm_delete_window;

            XSetWMProtocols(
                osw_gui[0].display,
                *w,
                atom,
                1
            );
	}

        
	return(0);
}


/*
 *	Destroy window.
 */
void OSWDestroyWindow(win_t *w)
{
	if(!IDC() ||
           (w == NULL)
	)
	    return;

	if(*w != 0)
	{
	    XDestroyWindow(osw_gui[0].display, *w);
	    *w = 0;
	}

	return;
}


/*
 *	GUI wrapper's set window icon function.
 */
void OSWSetWindowIcon(win_t w, pixmap_t icon, bool_t has_transparency)
{
        GC gc;
        XGCValues gcv;
	long supplied_return;

        XIconSize *icon_sizes;
        int count, i;
	unsigned int width = 64, height = 64;

	XWMHints wm_hints;
	XClassHint class_hints;
	XSizeHints sz_hints;

	osw_icon_record_struct old_icon;


        if(!IDC() ||
           (w == 0) ||
	   (icon == 0)
        )
            return;


	/* Check if this window w already has an icon. */
	old_icon.w = 0;
	old_icon.owner = 0;
	old_icon.pixmap = 0;
	old_icon.mask = 0;
	for(i = 0; i < osw_total_icon_records; i++)
        {
	    if(osw_icon_record[i].owner == w)
	    {
		/* Copy record to old_icon structure. */
		old_icon.w = osw_icon_record[i].w;
		old_icon.owner = osw_icon_record[i].owner;
		old_icon.pixmap = osw_icon_record[i].pixmap;
                old_icon.mask = osw_icon_record[i].mask;

		/* Reset record. */
		osw_icon_record[i].w = 0;
		osw_icon_record[i].owner = 0;
		osw_icon_record[i].pixmap = 0;
		osw_icon_record[i].mask = 0;

		break;
	    }
	}


	/* Set new icon referance in wm hints structure. */
	wm_hints.icon_pixmap = icon;

        /* Set class hint names. */
        class_hints.res_name = "Eterm"; /* Must call it that. */
        class_hints.res_class = "Eterm";


	/* Get original size hints. */
	XGetWMNormalHints(
	    osw_gui[0].display,
	    w,
	    &sz_hints,
	    &supplied_return
	);


	/* Get valid/suggested icon sizes. */
        if(
	    XGetIconSizes(
		osw_gui[0].display,
		osw_gui[0].root_win,
		&icon_sizes,
		&count
	    )
	)
	{
            for(i = 0; i < count; i++)
	    {
                width = MIN(icon_sizes[i].max_width, 64);
                height = MIN(icon_sizes[i].max_height, 64);
            }
            XFree(icon_sizes);
	}


	/* Create a 1 bit depth pixmap mask. */
        wm_hints.icon_mask = XCreatePixmap(
            osw_gui[0].display,
            osw_gui[0].root_win,
            width, height,
            1                           /* Depth of 1. */
        );
        /* Fetch current GC values. */
        XGetGCValues(osw_gui[0].display, osw_gui[0].gc, GCFunction, &gcv);

        /* Create tempory GC. */  
        gcv.function = GXcopy;
        gcv.plane_mask = 1;		/* Monochrome. */
        gcv.foreground = osw_gui[0].white_pix;
        gcv.background = osw_gui[0].black_pix;
        gcv.line_width = 1;
        gc = XCreateGC(
            osw_gui[0].display,
            wm_hints.icon_mask,
            GCFunction | GCPlaneMask | GCForeground | GCBackground |
                GCLineWidth,
            &gcv
        );
	/* Convert icon to a image and then `copy over' mask. */


	XSetForeground(osw_gui[0].display, gc, osw_gui[0].white_pix);
	XFillRectangle(
	    osw_gui[0].display,
	    wm_hints.icon_mask,
	    gc,
	    0, 0,
	    width, height
	);
        XFreeGC(osw_gui[0].display, gc);	/* Free temp GC. */



	/* Create window to be used for icon. */
        wm_hints.icon_window = XCreateSimpleWindow(
	    osw_gui[0].display,
	    w,			/* Parented to w (toplevel?). */
	    0, 0,
	    width, height,
	    0,
	    0L, 0L
	);

	XShapeCombineMask(
	    osw_gui[0].display,
	    wm_hints.icon_window,
	    ShapeBounding,
	    0, 0,
	    wm_hints.icon_mask,
	    ShapeSet
	);
	XSetWindowBackgroundPixmap(
	    osw_gui[0].display,
	    wm_hints.icon_window,
	    wm_hints.icon_pixmap
	);

	/* Extra stuff, may be needed. */
	wm_hints.window_group = w;
	wm_hints.input = True;
	wm_hints.initial_state = NormalState;

	wm_hints.flags = (
	    InputHint |
	    StateHint |
	    WindowGroupHint |
	    IconPixmapHint |
	    IconWindowHint |
	    IconMaskHint
	);


	/* Set new properties. */
	XSetWMProperties(
	    osw_gui[0].display,
	    w,
	    NULL, NULL,
	    (char **)NULL, 0,
	    &sz_hints,		/* Reset original size hints. */
	    &wm_hints,		/* WM icon hints. */
	    &class_hints	/* Nessasary gibberish. */
	);


	/* Delete old icon resources (as needed). */
/* X Seems to destroy it for us?
	OSWDestroyWindow(&old_icon.w);
if(old_icon.pixmap != 0)
 fprintf(stderr, "Deleted old icon 0x%.8x for 0x%.8x.\n",
  old_icon.pixmap,
  old_icon.owner
 );
	old_icon.owner = 0;
        OSWDestroyPixmap(&old_icon.pixmap);
        OSWDestroyPixmap(&old_icon.mask);
 */

	/* Record this icon information for future referance. */
	if(osw_total_icon_records < 0)
	    osw_total_icon_records = 0;
	for(i = 0; i < osw_total_icon_records; i++)
	{
	    if(osw_icon_record[i].owner == 0)
		break;
	}
	if(i >= osw_total_icon_records)
	{
	    /* Need to allocate more records. */
	    i = osw_total_icon_records;
	    osw_total_icon_records++;

	    osw_icon_record = (osw_icon_record_struct *)realloc(
	        osw_icon_record,
	        osw_total_icon_records * sizeof(osw_icon_record_struct)
	    );
	}
	if(osw_icon_record == NULL)
	{
	    osw_total_icon_records = 0;
	}
	else
	{
	    osw_icon_record[i].w = wm_hints.icon_window;
	    osw_icon_record[i].owner = w;
            osw_icon_record[i].pixmap = wm_hints.icon_pixmap;
            osw_icon_record[i].mask = wm_hints.icon_mask;
	}


	return;
}


/*
 *	Sets standard window manager properties for window w.
 */
void OSWSetWindowWMProperties(
        win_t w,
        char *title,
        char *icon_title,
        pixmap_t icon,
	bool_t wm_sets_coordinates,
        int x, int y,
        unsigned int min_width, unsigned int min_height,
        unsigned int max_width, unsigned int max_height,
        int frame_style,
        char **argv, int argc
)
{
	sizehints_t sizehints;
	win_t parent;
	PropMwmHints mwm_prop;		/* WM window decoration control. */
        XSetWindowAttributes swattr;


        if(!IDC() ||
           (w == 0)
        )
            return;


	if(title == NULL)
	    title = "Untitled";
	if(icon_title == NULL) 
            icon_title = "Untitled";


	memset(&sizehints, 0x00, sizeof(sizehints_t));
	if(wm_sets_coordinates)
	{
	    /* Let window manager set coordinates. */
	    sizehints.flags = PPosition | PSize | PMinSize | PMaxSize;
	    sizehints.x = 0;
	    sizehints.y = 0;
	}
	else
        {
            /* Use given input coordinates. */
            sizehints.flags = USPosition | PSize | PMinSize | PMaxSize;
            sizehints.x = x;
            sizehints.y = x;
        }


	/* Sanitize sizes. */
	if(max_width > osw_gui[0].display_width)
	    max_width = osw_gui[0].display_width;
	if(max_height > osw_gui[0].display_height)
	    max_height = osw_gui[0].display_height;
	if(max_width < 1)
	    max_width = 1;
	if(max_height < 1)
	    max_height = 1;

	if(min_width > max_width) min_width = max_width;
        if(min_height > max_height) min_height = max_height;

	/* Set sizes. */
        sizehints.min_width = min_width;
        sizehints.min_height = min_height;
        sizehints.max_width = max_width;
        sizehints.max_height = max_height;

	/* Set standard properties. */
        XSetStandardProperties(
            osw_gui[0].display,
            w,
            title, icon_title,
            icon,
            argv, argc,
            &sizehints
        );


        /*   Check if this is a toplevel window (a window parented to
	 *   the root window).  If it is, we need to set it's
	 *   `frame' and `decoration' values.
	 */
	parent = OSWGetWindowParent(w);
        if(parent == osw_gui[0].root_win)
        {
	    /* Set up mwm properties. */
            mwm_prop.flags = MWM_HINTS_FUNCTIONS |
			     MWM_HINTS_DECORATIONS;
/*
			     MWM_HINTS_INPUT_MODE |
			     MWM_HINTS_STATUS;
 */

            mwm_prop.functions = (MWM_FUNC_RESIZE   |
                                  MWM_FUNC_MOVE     |
                                  MWM_FUNC_MINIMIZE |
                                  MWM_FUNC_MAXIMIZE |
                                  MWM_FUNC_CLOSE
            );

            mwm_prop.decorations = (MWM_DECOR_BORDER   |
                                    MWM_DECOR_RESIZEH  |
                                    MWM_DECOR_TITLE    |
                                    MWM_DECOR_MENU     |
                                    MWM_DECOR_MINIMIZE |
                                    MWM_DECOR_MAXIMIZE
            );

	    mwm_prop.inputMode = 0;
            mwm_prop.status = 0;

	    /* Set frame style. */
	    switch(frame_style)
	    {
	      /* No frame, no title, no buttons... nothing. */
	      case WindowFrameStyleNaked:
                /* Set up the window attributes. */
		swattr.override_redirect = True;
		XChangeWindowAttributes(
		    osw_gui[0].display,
		    w,
		    CWOverrideRedirect,
		    &swattr
		);
		break;

	      /* Fixed frame. */
	      case WindowFrameStyleFixed:
                mwm_prop.decorations &= ~(MWM_DECOR_RESIZEH);
                mwm_prop.functions &= ~(MWM_FUNC_RESIZE);
		XChangeProperty(
		    osw_gui[0].display,
                    w,
		    osw_atom._motif_wm_hints,
		    osw_atom._motif_wm_hints,
		    32,				/* Bits. */
		    PropModeReplace,
		    (unsigned char *)&mwm_prop,
		    PROP_MWM_HINTS_ELEMENTS
		);
                break;

              /* Fixed frame, no title, no buttons. */
              case WindowFrameStyleFixedFrameOnly:
                mwm_prop.decorations &= ~(MWM_DECOR_RESIZEH  |
                                          MWM_DECOR_TITLE    |
                                          MWM_DECOR_MENU     |
                                          MWM_DECOR_MINIMIZE |
                                          MWM_DECOR_MAXIMIZE
                );
                mwm_prop.functions &= ~(MWM_FUNC_RESIZE   |
                                        MWM_FUNC_MINIMIZE |
                                        MWM_FUNC_MAXIMIZE
                );
                XChangeProperty(
                    osw_gui[0].display,
                    w,
                    osw_atom._motif_wm_hints,
                    osw_atom._motif_wm_hints,
                    32,                         /* Bits. */
                    PropModeReplace,
                    (unsigned char *)&mwm_prop,
                    PROP_MWM_HINTS_ELEMENTS
                );
                break;

              /* No close button or menu item. */
              case WindowFrameStyleNoClose:
                mwm_prop.functions &= ~(MWM_FUNC_CLOSE);
                XChangeProperty(
                    osw_gui[0].display,
                    w,
                    osw_atom._motif_wm_hints,
                    osw_atom._motif_wm_hints,
                    32,                         /* Bits. */
                    PropModeReplace,
                    (unsigned char *)&mwm_prop,
                    PROP_MWM_HINTS_ELEMENTS
                );
		break;

	      /* Standard. */
	      default:	/* WindowFrameStyleStandard */
		break;
	    }
        }

	OSWSetWindowIcon(w, icon, True);


	return;
}


/*
 *	Select events for window w to recieve.
 */
void OSWSetWindowInput(win_t w, eventmask_t eventmask)
{
	if(!IDC() ||
           (w == 0)
	)
	    return;

	XSelectInput(osw_gui[0].display, w, eventmask);

	return;
}

/*
 *	Sets wbum to be a transient window for wshelter.
 *
 *	Both wbum and wshelter need to be created and toplevel
 *	windows (windows parented to the root window).
 */
void OSWSetTransientFor(win_t wbum, win_t wshelter)
{
	if(!IDC() ||
           (wbum == 0) ||
	   (wshelter == 0)
	)
	    return;

	XSetTransientForHint(osw_gui[0].display, wbum, wshelter);

	return;
}


/*
 *	Set window title.
 */
void OSWSetWindowTitle(win_t w, char *title)
{
	if(!IDC() ||
           (w == 0) ||
	   (title == NULL)
	)
	    return;

	XStoreName(osw_gui[0].display, w, title);


	return;
}


/*
 *	Clear / refresh window.
 */
void OSWClearWindow(win_t w)
{
        if(!IDC() ||
           (w == 0)
        )
            return;

	XClearWindow(osw_gui[0].display, w);


	return;
}


/*
 *	Set window background color or tile.
 */
void OSWSetWindowBkg(win_t w, pixel_t pix, pixmap_t pixmap)
{
	if(!IDC() ||
           (w == 0)
	)
	    return;

	if(pixmap == 0)
	    XSetWindowBackground(osw_gui[0].display, w, pix);
	else
	    XSetWindowBackgroundPixmap(osw_gui[0].display, w, pixmap);

	return;
}


/*
 *	Get window attributes.
 */
int OSWGetWindowAttributes(win_t w, win_attr_t *wattr)
{
        if(!IDC() ||
           (wattr == NULL)
        )
            return(-1);

	if(w == 0)
	    memset(wattr, 0x00, sizeof(win_attr_t));
	else
	    XGetWindowAttributes(osw_gui[0].display, w, wattr);


	return(0);
}


/*
 *	Get window position relative to root_win.
 *
 *	Returns -2 if information cannot be obtained or is ambiguous.
 *	Returns -1 on general error.
 */
int OSWGetWindowRootPos(win_t w, int *x, int *y)
{
	win_t root_return;
	win_t child_return;
	int root_x_return, root_y_return;
        int win_x_return, win_y_return;
        unsigned int mask_return;
	bool_t b;


	if(!IDC() ||
	   (w == 0)
	)
	    return(-1);


	/*
	 *   Note: XLib has no low-level function to
	 *   obtain a windows' position relative to root.
	 *   We are fetching it through multiple steps through alternative
	 *   function calls.
	 */
	b = XQueryPointer(
	    osw_gui[0].display,
	    w,
	    &root_return, &child_return,
	    &root_x_return, &root_y_return,
            &win_x_return, &win_y_return,
	    &mask_return
	);


	if(b)
	{
            if(x != NULL)
                *x = root_x_return - win_x_return;  
            if(y != NULL)
                *y = root_y_return - win_y_return;
	}
	else
	{
	    /* Pointer is not on same window as w. */
	    if(x != NULL)
		*x = 0;
	    if(y != NULL)
		*y = 0;

	    return(-2);
	}


	return(0);
}



/*
 *	Get parent window id of window w.  Returns 0 on error.
 */
win_t OSWGetWindowParent(win_t w)
{
	int status;
        win_t parent_rtn;
        win_t root_return;   
        win_t *children_return;
        unsigned int nchildren_return;


        /* Error checks. */
        if(!IDC() ||
           (w == 0) ||
           (osw_gui[0].root_win == 0)
        )
            return(0);

        /* Check if w is already root window? */
        if(osw_gui[0].root_win == w)
            return(osw_gui[0].root_win);


        /* Get tree. */
        children_return = NULL;
        status = XQueryTree(
            osw_gui[0].display,
            w,
            (win_t *)&root_return,
            (win_t *)&parent_rtn,
            (win_t **)&children_return,
            (unsigned int *)&nchildren_return
        );
            
   
        /* XQueryTree() returns zero (yes zero) if it failed. */
        if(status == 0)
        {
            fprintf(stderr,  
                "WidgetGetWindowParent(): XQueryTree(): Failed.\n"
            );
            return(0); 
        }

        /* Need to free children_return? */
        if(children_return != NULL)
            XFree((void *)children_return);
            

        return(parent_rtn);
}



/*
 *	Checks if window grand_child is really a decendant of window
 *	grand_parent.
 */
bool_t OSWCheckWindowAncestory(win_t grand_parent, win_t grand_child)
{
        static int count;
        static win_t test_w, old_w;
        static win_t root_w;
        

        /* Error checks. */
        if(!IDC() ||
           (osw_gui[0].root_win == 0)
        )
	    return(False); 

        
        /* Get root window. */
        root_w = osw_gui[0].root_win;
        
        
        /* Check for consiquential match. */
        if(grand_parent == grand_child)
            return(True);
        else if((grand_child == root_w) || (grand_child == 0))
            return(False);
        else if((grand_parent == root_w) || (grand_parent == 0))
            return(False);
            
            
        /* Begin checking for ancestry. */
        test_w = grand_child;
        for(count = 0; count < 16; count++)   
        {
            /* Check if test_w is grand_parent. */
            if(test_w == grand_parent)
                return(True);
  
   
            /* Get test_w parent as test_w. */
            old_w = test_w;
            test_w = OSWGetWindowParent(old_w);
 

            /* Make sure test_w is valid. */
            if(test_w == 0)   
                return(False);
            else if(test_w == root_w)
                return(False);
        }
        
        
        /* Too many recursions, return False. */
        return(False);
}       



/*
 *	Map window w.
 */
void OSWMapWindow(win_t w)
{
	if(!IDC() ||
           (w == 0)
	)
	    return;

	XMapWindow(osw_gui[0].display, w);


	return;
}



/*
 *	Map and raise window w.
 */
void OSWMapRaised(win_t w)
{
        if(!IDC() ||
           (w == 0)
        )
            return;

	XMapRaised(osw_gui[0].display, w);

	return;
}



/*
 *	Map all child windows.
 */
void OSWMapSubwindows(win_t w)
{
        if(!IDC() ||
           (w == 0)
        )
            return; 

	XMapSubwindows(osw_gui[0].display, w);


	return;
}


/*
 *	Unmap window.
 */
void OSWUnmapWindow(win_t w)
{
        if(!IDC() ||
           (w == 0)
        )
            return;


	XUnmapWindow(osw_gui[0].display, w);


	return;
}


/*
 *	Changes the order of stacking of the given windows
 *	in the array w (from top to bottom).
 */
void OSWRestackWindows(win_t *w, int num_w)
{
	int i, n;


        if(!IDC() ||
           (w == NULL) ||
           (num_w <= 0)
        )
            return;


	/* Remove windows with index values of 0. */
	for(i = 0; i < num_w; i++)
	{
	    while((w[i] == 0) && (i < num_w))
	    {
		num_w--;

		for(n = i; n < num_w; n++)
		    w[n] = w[n + 1];
	    }
	}


	XRestackWindows(
	    osw_gui[0].display,
	    w,
	    num_w
	);


	return;
}


/*
 *	Iconifies window.   The window should be a toplevel window.
 */
int OSWIconifyWindow(win_t w)
{
	if(!IDC() ||
           (w == 0)
	)
	    return(-1);


	XIconifyWindow(
	    osw_gui[0].display,
	    w,
	    osw_gui[0].scr_num
	);


	return(0);
}

/*
 *	Reparent window.
 */
void OSWReparentWindow(win_t w, win_t parent)
{
	if(!IDC() ||
           (w == 0) ||
           (parent == 0)
        )
            return;

	XReparentWindow(osw_gui[0].display, w, parent, 0, 0);


	return;
}



/*
 *	Move window.
 */
void OSWMoveWindow(win_t w, int x, int y)
{
	if(!IDC() ||
           (w == 0)
	)
	    return;

	XMoveWindow(osw_gui[0].display, w, x, y);


        return;
}



/*
 *	Resize window.
 */
void OSWResizeWindow(win_t w, unsigned int width, unsigned int height)
{
        if(!IDC() ||
           (w == 0)
        )
            return;

	XResizeWindow(osw_gui[0].display, w, width, height);


        return;
}



/*
 *	Move and resize window in one step.
 */
void OSWMoveResizeWindow(
	win_t w,
	int x, int y,
        unsigned int width, unsigned int height)
{
        if(!IDC() ||
           (w == 0)
        )
            return;

	XMoveResizeWindow(osw_gui[0].display, w, x, y, width, height);


	return;
}



/*
 *	Create a graphics buffer / pixmap.
 */
int OSWCreatePixmap(pixmap_t *pixmap, unsigned int width, unsigned int height)
{
	if(!IDC() ||
           (osw_gui[0].root_win == 0) ||
           (pixmap == NULL) ||
           (width == 0) ||
           (height == 0) ||
           (osw_gui[0].depth == 0)
	)
	    return(-1);


	*pixmap = XCreatePixmap(
	    osw_gui[0].display,
	    osw_gui[0].root_win,
	    width,
	    height,
	    osw_gui[0].depth
	);
	if(*pixmap == 0)
	    return(-1);


	return(0);
}



/*
 *	Destroy a graphics buffer / Pixmap.
 */
void OSWDestroyPixmap(pixmap_t *pixmap)
{
        if(!IDC() ||  
           (pixmap == NULL)
        )
	    return;

	if(*pixmap != 0)
	{
	    XFreePixmap(osw_gui[0].display, *pixmap);
	    *pixmap = 0;
	}


	return;
}


/*
 *	Clear a graphics buffer / Pixmap.
 */
void OSWClearPixmap(
	pixmap_t pixmap,
	unsigned int width, unsigned int height,
	pixel_t pix
)
{
        if(!IDC() ||   
           (pixmap == 0) ||
           (width == 0) ||
           (height == 0)
        )
            return;


	OSWSetFgPix(pix);

	OSWDrawSolidRectangle(
	    (drawable_t)pixmap,
	    0, 0,
	    width, height
	);


	return;
}


/*
 *	Create an image.
 */
int OSWCreateImage(
	image_t **image,
        unsigned int width, unsigned int height
)
{
        char *data;


        /* Error checks. */
        if(!IDC() ||
           (image == NULL) ||
	   (width == 0) ||
	   (height == 0)
        )
            return(-1);


        /* Width and height must be even number. */
        if(IS_NUM_ODD(width)) width += 1;
        if(IS_NUM_ODD(height)) height += 1;


        /* ******************************************************* */
        /* Create an image according to depth. */

        /* 8 bits. */
        if(osw_gui[0].depth == 8)
        {
            data = (char *)calloc(1, width * height * BYTES_PER_PIXEL8);
            if(data == NULL)
            {
                fprintf(stderr,
 "OSWCreateImage(): Memory allocation error for %i by %i image.\n",
                    width, height
                );
                return(-1);
            }

            *image = XCreateImage(
                osw_gui[0].display,
                osw_gui[0].visual,
                osw_gui[0].depth,
                ZPixmap,
                0,
                data,           /* Data. */
                width,
                height,
                8,		/* Bit padding (should be 8). */
                0               /* Bytes per line (should be 0). */
            );
        }
        /* 15 bits. */
        else if(osw_gui[0].depth == 15)
        {
	    /* Treat 15 bits as 16 bits. */
            data = (char *)calloc(1, width * height * BYTES_PER_PIXEL16);
            if(data == NULL)
            {
                fprintf(stderr,
 "OSWCreateImage(): Memory allocation error for %i by %i image.\n",
                    width, height
                );
                return(-1);
            }

            *image = XCreateImage(
                osw_gui[0].display,
                osw_gui[0].visual,
                osw_gui[0].depth,
                ZPixmap,
                0,
                data,           /* Data. */
                width,
                height,
                16,             /* Bit padding (treat as 16). */
                0               /* Bytes per line (should be 0). */
            );
        }
        /* 16 bits. */
        else if(osw_gui[0].depth == 16)
        {
            data = (char *)calloc(1, width * height * BYTES_PER_PIXEL16);
            if(data == NULL)
            {
                fprintf(stderr,
 "OSWCreateImage(): Memory allocation error for %i by %i image.\n",
                    width, height
                );
                return(-1);
            }

            *image = XCreateImage(
                osw_gui[0].display,
                osw_gui[0].visual,
                osw_gui[0].depth,
                ZPixmap,
                0,
                data,           /* Data. */
                width,
                height,
                16,             /* Bit padding. */
                0               /* Bytes per line (should be 0). */
            );
        }
        /* 24 or 32 bits. */
        else if((osw_gui[0].depth == 24) ||
                (osw_gui[0].depth == 32)
        )
        {
            data = (char *)calloc(1, width * height * BYTES_PER_PIXEL32);
            if(data == NULL)
            {
                fprintf(stderr,
 "OSWCreateImage(): Memory allocation error for %i by %i image.\n",
                    width, height
                );
                return(-1);
            }

            *image = XCreateImage(
                osw_gui[0].display,
                osw_gui[0].visual,
                osw_gui[0].depth,
                ZPixmap,
                0,
                data,           /* Data. */
                width, 
                height,
                32,             /* Bit padding (must be 32). */
                0               /* Bytes per line (should be 0). */
            );
        }


        /* Failed to create image? */
        if(*image == NULL)
            return(-1);


        return(0);
}



/*
 *      Destroys an image.
 */
void OSWDestroyImage(image_t **image)
{
        if(!IDC() ||
           (image == NULL)
        )
            return;
            
            
        if(*image != NULL)
        {
            XDestroyImage(*image);
            *image = NULL;
        }
         

        return;
}


/*
 *	Create shared memory image.
 */
int OSWCreateSharedImage(
	shared_image_t **image,
        unsigned int width,
        unsigned int height
)
{
#ifdef USE_XSHM
	XShmSegmentInfo *shm_seg_ptr;
#endif	/* USE_XSHM */
	int depth;
	image_t *ximage_ptr;


#ifdef USE_XSHM
	if(osw_gui[0].def_use_shm)
	{
	    if(!IDC() ||
               (image == NULL) ||
               (width == 0) ||
               (height == 0)
            )
                return(-1);


	    /* Width and height must be even number. */
	    if(IS_NUM_ODD(width))
	        width += 1;
	    if(IS_NUM_ODD(height))
	        height += 1;


	    /* Allocate shared_image_t structure. */
	    *image = (shared_image_t *)malloc(
	        sizeof(shared_image_t)
	    );
	    if(*image == NULL)
	        return(-1);


	    /* Get pointer to shm segment info. */
	    shm_seg_ptr = &((*image)->shminfo);

	    /* Clear shared memory info. */
	    memset(
	        shm_seg_ptr,
		0x00,
	        sizeof(XShmSegmentInfo)
	    );

	    /* Get proper depth. */
	    switch(osw_gui[0].depth)
	    {
	      case 15:
                depth = 16;
                break;

	      case 24:
                depth = 32;
                break;

	      default:
                depth = osw_gui[0].depth;
	    }


            /* Create shared image. */
            ximage_ptr = XShmCreateImage(
                osw_gui[0].display,
                osw_gui[0].visual,	/* Visual. */
                osw_gui[0].depth,	/* Bit depth. */
                ZPixmap,		/* Format. */
                NULL,			/* Actual data. */
                shm_seg_ptr,
                width,			/* Width. */
                height			/* Height. */
            );
            if(ximage_ptr == NULL)
	    {
	        free(*image);
	        *image = NULL;
                return(-1);
	    }
	    else
	    {
	        (*image)->ximage = ximage_ptr;
	    }

            /* Copy values from ximage_ptr to shared image struct header. */
            (*image)->byte_order = ximage_ptr->byte_order;
            (*image)->xoffset = ximage_ptr->xoffset;
            (*image)->format = ximage_ptr->format;
            (*image)->data = (u_int8_t *)ximage_ptr->data;

            (*image)->bytes_per_line = ximage_ptr->bytes_per_line;
            (*image)->bits_per_pixel = ximage_ptr->bits_per_pixel;
            (*image)->bitmap_pad = ximage_ptr->bitmap_pad;

            (*image)->width = ximage_ptr->width;
            (*image)->height = ximage_ptr->height;
            (*image)->depth = ximage_ptr->depth;
            (*image)->red_mask = ximage_ptr->red_mask;
            (*image)->green_mask = ximage_ptr->green_mask;
            (*image)->blue_mask = ximage_ptr->blue_mask;


            /* Get shared memory ID. */
            shm_seg_ptr->shmid = shmget(
                IPC_PRIVATE,
                ximage_ptr->width * ximage_ptr->height *
		    (depth >> 3),	/* Size. */
                IPC_CREAT | 0777
            );
            if(shm_seg_ptr->shmid < 0)
            {
                perror("Getting shared memory ID");
                return(-1);
            }

            /* Attach shared memory and check for errors. */
            shm_seg_ptr->shmaddr = ximage_ptr->data = (char *)shmat(
                shm_seg_ptr->shmid, 0, 0
	    );
            if(shm_seg_ptr->shmaddr == (char *)-1)
            {
                perror("Attaching shared memory ID");
                return(-1);
            }

            /* Set shared memory as read/write. */
            shm_seg_ptr->readOnly = False;

	    /* Attached shared memory to the GUI. */
            XShmAttach(osw_gui[0].display, shm_seg_ptr);


	    /* Need to update pointer to data. */
            (*image)->data = (u_int8_t *)ximage_ptr->data;
	}
	else
	{
#endif  /* USE_XSHM */
            if(!IDC() ||
               (image == NULL) ||
               (width == 0) ||
               (height == 0)
            )
                return(-1);


            /* Allocate shared_image_t structure. */
            *image = (shared_image_t *)malloc(
                sizeof(shared_image_t)
            );
            if(*image == NULL)
                return(-1);


	    /* Create regular image. */
	    if(OSWCreateImage(&ximage_ptr, width, height))
	    {
	        free(*image);
	        *image = NULL;

	        return(-1);
	    }
            if(ximage_ptr == NULL)
            {
                free(*image);
                *image = NULL;

                return(-1);
            }
	    else
	    {
	        (*image)->ximage = ximage_ptr;
	    }

            /* Copy values from ximage_ptr to shared image struct header. */
            (*image)->byte_order = ximage_ptr->byte_order;
            (*image)->xoffset = ximage_ptr->xoffset;
            (*image)->format = ximage_ptr->format;
            (*image)->data = (u_int8_t *)ximage_ptr->data;

            (*image)->bytes_per_line = ximage_ptr->bytes_per_line;
            (*image)->bits_per_pixel = ximage_ptr->bits_per_pixel;
            (*image)->bitmap_pad = ximage_ptr->bitmap_pad;

            (*image)->width = ximage_ptr->width;
            (*image)->height = ximage_ptr->height;
            (*image)->depth = ximage_ptr->depth;

            (*image)->red_mask = ximage_ptr->red_mask;
            (*image)->green_mask = ximage_ptr->green_mask;
            (*image)->blue_mask = ximage_ptr->blue_mask;
#ifdef USE_XSHM
	}
#endif  /* USE_XSHM */

	return(0);
}



/*
 *	Destroys a shared image.
 */
void OSWDestroySharedImage(
        shared_image_t **image
)
{
#ifdef USE_XSHM
	XShmSegmentInfo *shm_seg_ptr;
	struct shmid_ds shm_stats_buf;
#endif	/* USE_XSHM */
	image_t *ximage_ptr;


#ifdef USE_XSHM
        if(osw_gui[0].def_use_shm)
        {
            if(!IDC() ||
               (image == NULL)
            )
                return;
	    if(*image == NULL)
	        return;
	    if((*image)->ximage == NULL)
	        return;

	    /* Get pointers. */
	    shm_seg_ptr = &(*image)->shminfo;
	    ximage_ptr = (*image)->ximage;


            /* Get statistics of shared memory segment. */
	    memset(&shm_stats_buf, 0x00, sizeof(struct shmid_ds));
            shmctl(shm_seg_ptr->shmid, IPC_STAT, &shm_stats_buf);

            /* Detach shared memory from GUI. */
            XShmDetach(osw_gui[0].display, shm_seg_ptr);

            /* Destroy the image. */
	    OSWDestroyImage(&ximage_ptr);
	    (*image)->ximage = NULL;

            /* Detach shared memory. */
            shmdt(shm_seg_ptr->shmaddr);
            shm_stats_buf.shm_nattch = 0;	/* Explicit set # attachs to 0. */

            /* Mark shm segment as destroyed. */
            shmctl(shm_seg_ptr->shmid, IPC_RMID, &shm_stats_buf);


	    /* Deallocate shared image structure. */
	    free(*image);
	    *image = NULL;
	}
	else
	{
#endif	/* USE_XSHM */
            if(!IDC() ||
               (image == NULL)
            )
                return;
            if(*image == NULL)
                return;

  
            /* Get pointer to image. */
            ximage_ptr = (*image)->ximage;

	    /* Destroy the image normally. */
            OSWDestroyImage(&ximage_ptr);


            /* Deallocate shared image structure. */
            free(*image);
            *image = NULL;
#ifdef USE_XSHM
	}
#endif  /* USE_XSHM */


        return;
}


/*
 *	Create a graphics buffer / pixmap from image.
 */
pixmap_t OSWCreatePixmapFromImage(image_t *image)
{
	pixmap_t pixmap;


        /* Error checks. */
        if(!IDC() ||
           (osw_gui[0].root_win == 0)
	)
            return(0);
        if(image == NULL)
            return(0);
        else if(image->data == NULL)
            return(0);


        /* ************************************************************** */

        /* Create the pixmap. */
	if(
	    OSWCreatePixmap(
		&pixmap,
		image->width,
		image->height
	    )
	)
            return(0);


        /* Copy the image to the pixmap. */
	OSWPutImageToDrawable(image, (drawable_t)pixmap);


        return(pixmap);
}



image_t *OSWGetImage(
	drawable_t d,
	int x, int y,
	unsigned int width, unsigned int height
)
{
	static image_t *image;


	if(!IDC() ||
           (d == 0) ||
           (width == 0) ||
           (height == 0)
	)
	    return(NULL);


	image = (image_t *)XGetImage(
            osw_gui[0].display,
            d,
            x, y,
	    width, height,
            AllPlanes,
            ZPixmap
        );

	OSWGUISync(False);


	return(image);
}



/*
 *	Puts an image to a drawable.
 */
void OSWPutImageToDrawable(image_t *image, drawable_t d)
{
        if(!IDC() ||
           (image == NULL) ||
           (d == 0)
        )
            return;


        XPutImage(
            osw_gui[0].display,
            d,
            osw_gui[0].gc,
            image,
            0, 0,
            0, 0,
            image->width, image->height
        );


	return;
}



/*
 *	Puts image to drawable at a specific position.
 */
void OSWPutImageToDrawablePos(
	image_t *image, drawable_t d,
        int tar_x, int tar_y
)
{
        if(!IDC() ||
           (image == NULL) ||
           (d == 0)
        )
            return;


        XPutImage(
            osw_gui[0].display,
            d,
            osw_gui[0].gc,
            image,
            0, 0,
            tar_x, tar_y,
            image->width, image->height
        );


        return;
}


/*
 *	Puts section of image to drawable at a specific position.
 */
void OSWPutImageToDrawableSect(
        image_t *image, drawable_t d,  
        int tar_x, int tar_y,
	int src_x, int src_y,
	unsigned int width, unsigned int height
)
{         
        if(!IDC() ||
           (image == NULL) ||
           (d == 0)
        )
            return;
 
   
        XPutImage(
            osw_gui[0].display,
            d,
            osw_gui[0].gc,
            image,
            src_x, src_y,
            tar_x, tar_y,
            width, height
        );


        return;
}  



/*
 *	Puts a shared image to a drawable.
 *
 *	If USE_XSHM is not defined then this function calls
 *	OSWPutImageToDrawable()
 */
void OSWPutSharedImageToDrawable(shared_image_t *image, drawable_t d)
{
#ifdef USE_XSHM
        unsigned long CompletionType;
        event_t xevent;


        if(osw_gui[0].def_use_shm)
	{
	    if(!IDC() ||
               (image == NULL) ||
               (d == 0)
	    )
	        return;

	    if(image->ximage == NULL)
	        return;

            if(osw_gui[0].def_sync_shm)
            {
                /* Put and sync. */
                XShmPutImage(
                    osw_gui[0].display,
                    d,
                    osw_gui[0].gc,
                    image->ximage,
                    0, 0,
                    0, 0,
                    image->ximage->width, image->ximage->height,
                    True
                );

                CompletionType = XShmGetEventBase(osw_gui[0].display) +
                    ShmCompletion;
                    
                /* Wait untill image is put. */
                while(   
                    XCheckTypedWindowEvent(
                        osw_gui[0].display,
			d,
                        CompletionType,
                        &xevent
                    ) == False
                );
            }
            else
            {
                XShmPutImage(
                    osw_gui[0].display,
                    d,
                    osw_gui[0].gc,
                    image->ximage,
                    0, 0,
                    0, 0,
                    image->ximage->width, image->ximage->height,
                    False
                );
	    }
	}
	else
	{
#endif	/* USE_XSHM */
            if(image == NULL)
                return;

	    OSWPutImageToDrawable(image->ximage, d);

#ifdef USE_XSHM
	}
#endif /* USE_XSHM */

	return;
}


/*
 *      Puts image to drawable at a specific position.
 *
 *      If USE_XSHM is not defined then this function calls
 *      OSWPutImageToDrawablePos()
 */
void OSWPutSharedImageToDrawablePos(
	shared_image_t *image, drawable_t d,
	int tar_x, int tar_y
)
{
#ifdef USE_XSHM
        unsigned long CompletionType;
        event_t xevent;


        if(osw_gui[0].def_use_shm)
        { 
            if(!IDC() ||
               (image == NULL) ||
               (d == 0)
            )
                return;

            if(image->ximage == NULL)
                return;

            if(osw_gui[0].def_sync_shm)
            {  
                /* Put and sync. */
                XShmPutImage(
                    osw_gui[0].display,
                    d,
                    osw_gui[0].gc,
                    image->ximage,
                    0, 0,   
                    tar_x, tar_y,
                    image->ximage->width, image->ximage->height,
                    True
                );

                CompletionType = XShmGetEventBase(osw_gui[0].display) +
                    ShmCompletion;
 
                /* Wait untill image is put. */
                while(
                    XCheckTypedWindowEvent(
                        osw_gui[0].display,
			d,
                        CompletionType,
                        &xevent
                    ) == False
                );
	    }
	    else
	    {
                XShmPutImage(
                    osw_gui[0].display,
                    d,
                    osw_gui[0].gc,
                    image->ximage,
                    0, 0,
                    tar_x, tar_y,
                    image->ximage->width, image->ximage->height,
                    False
                );
	    }
	}
	else
	{
#endif	/* USE_XSHM */
            if(image == NULL)   
                return;

            OSWPutImageToDrawablePos(image->ximage, d, tar_x, tar_y);
#ifdef USE_XSHM
	}
#endif /* USE_XSHM */

	return;
}


/*
 *      Puts section of image to drawable at a specific position.
 *
 *      If USE_XSHM is not defined then this function calls
 *      OSWPutImageToDrawableSect()
 */
void OSWPutSharedImageToDrawableSect(
        shared_image_t *image, drawable_t d,
        int tar_x, int tar_y,
        int src_x, int src_y,
        unsigned int width, unsigned int height
)       
{
#ifdef USE_XSHM
        unsigned long CompletionType;
        event_t xevent;


        if(osw_gui[0].def_use_shm)
        {
            if(!IDC() ||
               (image == NULL) ||
               (d == 0)
            )
	        return;
            if(image->ximage == NULL)
                return;

	    if(osw_gui[0].def_sync_shm)
	    {
		/* Put and sync. */
                XShmPutImage(
                    osw_gui[0].display,
                    d,
                    osw_gui[0].gc,
                    image->ximage,
                    src_x, src_y,
                    tar_x, tar_y,
                    width, height,   
                    True
                );

                CompletionType = XShmGetEventBase(osw_gui[0].display) +
                    ShmCompletion;

                /* Wait untill image is put. */
                while(
		    XCheckTypedWindowEvent(
			osw_gui[0].display,
			d,
			CompletionType,
                        &xevent
		    ) == False
                );
	    }
	    else
	    {
		/* Just put, no sync. */
                XShmPutImage(
                    osw_gui[0].display,
                    d,
                    osw_gui[0].gc,
                    image->ximage,
                    src_x, src_y,
                    tar_x, tar_y,
                    width, height,
                    False
                );
	    }
	}
	else
	{  
#endif	/* USE_XSHM */
            if(image == NULL)
                return; 

            OSWPutImageToDrawableSect(
	        image->ximage, d,
	        tar_x, tar_y,
	        src_x, src_y,
	        width, height
	    );
#ifdef USE_XSHM
	}
#endif /* USE_XSHM */

        return;
}


/*
 *	Syncronizes shared image with current thread of execution.
 *
 *	A short delay may occure due to the time needed to sync.
 */
void OSWSyncSharedImage(shared_image_t *image, drawable_t d)
{
#ifdef USE_XSHM
        unsigned long CompletionType;
        event_t xevent;

        if(osw_gui[0].def_use_shm)
	{
            if(!IDC() ||
               (image == NULL) ||
               (d == 0)
            )
                return;
	    if(image->ximage == NULL)
	        return;


            XShmPutImage(
                osw_gui[0].display,
                d,
                osw_gui[0].gc,
                image->ximage,
                0, 0,
                0, 0,
                image->ximage->width,
                image->ximage->height,
                True
            );

            CompletionType = XShmGetEventBase(osw_gui[0].display) +
	        ShmCompletion;

            /* Wait for shared memory redraw completion. */
            while(XCheckTypedWindowEvent(
		osw_gui[0].display,
		d,
		CompletionType,
		&xevent) == False
	    )
            {
                usleep(OSW_SYNC_SLEEP_INTERVAL * 1000);
            }
	}
#endif /* USE_XSHM */

	return;
}


/*
 *	Puts a graphics buffer (pixmap_t) to window.
 *	Both the graphics buffer and the window should be of the
 *	same size.
 */
void OSWPutBufferToWindow(win_t w, gbuf_t gbuf)
{
	static win_attr_t wattr;


	if(!IDC() ||
           (w == 0) ||
           (gbuf == 0)
        )
	    return;


	OSWGetWindowAttributes(w, &wattr);
/*
	OSWSetWindowBkg(w, 0, (pixmap_t)gbuf);
 */

	OSWCopyDrawables(
	    (drawable_t)w,
	    (drawable_t)gbuf,
	    wattr.width,
	    wattr.height
	);


	return;
}


/*
 *	Copy drawables.
 */
void OSWCopyDrawables(
	drawable_t tar_d,  
        drawable_t src_d,
	unsigned int width,
	unsigned int height
)
{
	if(!IDC() ||
           (tar_d == 0) ||
           (src_d == 0) ||
           (width == 0) ||
           (height == 0)
	)
	    return;


        XCopyArea(
	    osw_gui[0].display,
	    src_d, tar_d,
            osw_gui[0].gc,
	    0, 0, width, height, 0, 0
	);


	return;
}




/*
 *	Copy drawables with coordinates.
 */
void OSWCopyDrawablesCoord(
	drawable_t tar_d,
        drawable_t src_d,
        int tar_x, int tar_y,
        unsigned int width, unsigned int height,
        int src_x, int src_y
)
{
        if(!IDC() ||
           (tar_d == 0) ||
           (src_d == 0) ||
           (width == 0) ||
           (height == 0)
        )
            return;


        XCopyArea(
	    osw_gui[0].display,
	    src_d, tar_d,
	    osw_gui[0].gc,
            src_x, src_y,
	    width, height,
	    tar_x, tar_y
        );
        
        return;
}



/*
 *	Draw string.
 */
void OSWDrawString(drawable_t d, int x, int y, char *string)
{
	if(!IDC() ||
           (d == 0) ||
           (string == NULL)
	)
	    return;

	XDrawString(
	    osw_gui[0].display, d, osw_gui[0].gc,
	    x, y, string, strlen(string)
	);

	return;
}



/*
 *      Draw string limited.
 */
void OSWDrawStringLimited(drawable_t d, int x, int y, char *string, int len)
{
	int real_len;


        if(!IDC() ||
           (d == 0) ||
           (string == NULL) ||
           (len < 1)
        )
            return;

	real_len = strlen(string);
	if(len > real_len)
	    len = real_len;
 
        XDrawString(
	    osw_gui[0].display, d, osw_gui[0].gc,
            x, y, string, len
        );

        return;
}



/*
 *	Draw line.
 */
void OSWDrawLine(drawable_t d, int start_x, int start_y,
	int end_x, int end_y)
{
        if(!IDC() ||
           (d == 0)
        )
            return;

	XDrawLine(
	    osw_gui[0].display, d, osw_gui[0].gc,
	    start_x, start_y,
	    end_x, end_y
	);

	return;
}


/*
 *	Draw rectangle.
 */
void OSWDrawRectangle(drawable_t d, int x, int y,
	unsigned int width, unsigned int height)
{
        if(!IDC() ||
           (d == 0) ||
           (width == 0) ||
	   (height == 0)
        ) 
            return;

	XDrawRectangle(
	    osw_gui[0].display, d, osw_gui[0].gc,
	    x, y, width, height
	);

	return;
}



/*
 *	Draw solid rectangle.
 */
void OSWDrawSolidRectangle(drawable_t d, int x, int y,
	unsigned int width, unsigned int height)
{
        if(!IDC() ||
           (d == 0) ||
           (width == 0) ||
           (height == 0)
        )
            return;

	XFillRectangle(
	    osw_gui[0].display, d, osw_gui[0].gc,
            x, y, width, height
	);

	return;
}



/*
 *	Draw arc, angles are in radians.
 */
void OSWDrawArc(drawable_t d, int x, int y,
	unsigned int width, unsigned int height,
        double position_angle,
        double terminal_angle
)
{
        if(!IDC() ||
           (d == 0) ||
           (width == 0) ||
           (height == 0)
        )
            return;

	XDrawArc(
	    osw_gui[0].display, d, osw_gui[0].gc,
	    x, y,
	    width, height,
	    position_angle * 180 / PI * 64,
	    terminal_angle * 180 / PI * 64
	);

	return;
}



/* 
 *	Draw solid arc, angles are in radians.
 */
void OSWDrawSolidArc(drawable_t d, int x, int y,
	unsigned int width, unsigned int height,
        double position_angle,
        double terminal_angle
)
{
        if(!IDC() ||
           (d == 0) ||   
           (width == 0) ||
           (height == 0)
        ) 
            return;

        XFillArc(
	    osw_gui[0].display, d, osw_gui[0].gc,
            x, y,
            width, height,
            position_angle * 180 / PI * 64,
            terminal_angle * 180 / PI * 64
        );
 
        return;
}



/*
 *	GUI Error handler.
 */
int OSWXErrorHandler(
	Display *da_display,
	XErrorEvent *da_error_event
)
{

	/* Input error checks. */
	if((da_display == NULL) ||
	   (da_error_event == NULL)
	)
	    return(0);


	/* Ignore success error code. */
	if(da_error_event->error_code == Success)
	    return(0);


	/* ******************************************************** */
	/* Ignore errors list. */

	/* False GetImage errors ignored. */
	if(da_error_event->request_code == X_GetImage)
	    return(0);


	/* ********************************************************* */

	fprintf(stderr,
 "\nSubsystems message: X server error:\n\n"
	);

	/* Error type. */
	fprintf(stderr,
 "        Error type: %i\n", da_error_event->type
	);

	/* Display. */
        fprintf(stderr,
 "        X server display connection pointer: 0x%.8x\n",
	    (u_int32_t)da_error_event->display
        );

	/* Serial number. */
        fprintf(stderr,
 "        Serial number of failed request: %i\n",
	    (int32_t)da_error_event->serial
        );

	/* Print error code. */
        fprintf(stderr,
 "        Error code of failed request: %i (",
           (int32_t)da_error_event->error_code
        );
	switch(da_error_event->error_code)
	{
	  case BadRequest:
	    printf("BadRequest");
	    break;

	  case BadValue:
            printf("BadValue");
            break;

          case BadWindow:
            printf("BadWindow");
            break;

          case BadPixmap:
            printf("BadPixmap");
            break;

          case BadAtom:
            printf("BadAtom");
            break;

          case BadCursor:
            printf("BadCursor");
            break;

          case BadFont:
            printf("BadFont");
            break;

          case BadMatch:
            printf("BadMatch");
            break;

          case BadDrawable:
            printf("BadDrawable"); 
            break;

          case BadAccess:
            printf("BadAccess");
            break;

          case BadAlloc:
            printf("BadAlloc");
            break;

          case BadColor:
            printf("BadColor");
            break;

          case BadGC:
            printf("BadGC");
            break;

          case BadIDChoice:
            printf("BadIDChoice");
            break;

          case BadName:
            printf("BadName");
            break;

          case BadLength:
            printf("BadLength");
            break;

          case BadImplementation:
            printf("BadImplementation");
            break;

	  default:
            printf("Unknown");
            break;
	}
	printf(")\n");

	/* Major and minor operation code. */
        fprintf(stderr,
 "        Major op-code of failed request: %i (", da_error_event->request_code
        );
	switch(da_error_event->request_code)
	{
	  case X_CreateWindow:
	    printf("CreateWindow");
	    break;

	  case X_ChangeWindowAttributes:
            printf("ChangeWindowAttributes");
            break;

          case X_GetWindowAttributes:
            printf("GetWindowAttributes");
            break;

          case X_DestroyWindow:
            printf("DestroyWindow");
            break;

          case X_DestroySubwindows:
            printf("DestroySubwindows");
            break;

          case X_ChangeSaveSet:
            printf("ChangeSaveSet");
            break;

          case X_ReparentWindow:
            printf("ReparentWindow");
            break;

          case X_MapWindow:
            printf("MapWindow");
            break;

          case X_MapSubwindows:
            printf("MapSubwindows");
            break;

          case X_UnmapWindow:
            printf("UnmapWindow");
            break;

          case X_UnmapSubwindows:
            printf("UnmapSubwindows");
            break;

          case X_ConfigureWindow:
            printf("ConfigureWindow");
            break;

          case X_CirculateWindow:
            printf("CirculateWindow");
            break;

          case X_GetGeometry:
            printf("GetGeometry");
            break;

          case X_QueryTree:
            printf("QueryTree");
            break;

          case X_InternAtom:
            printf("InternAtom");
            break;

          case X_GetAtomName:
            printf("GetAtomName");
            break;

          case X_ChangeProperty:
            printf("ChangeProperty");
            break;

          case X_DeleteProperty:
            printf("DeleteProperty");
            break;

          case X_GetProperty:
            printf("GetProperty");
            break;

          case X_ListProperties:
            printf("ListProperties");
            break;

          case X_SetSelectionOwner:
            printf("SetSelectionOwner");
            break;

          case X_GetSelectionOwner:
            printf("GetSelectionOwner");
            break;

          case X_ConvertSelection:
            printf("ConvertSelection");
            break;

          case X_SendEvent:
            printf("SendEvent");
            break;

          case X_GrabPointer:
            printf("GrabPointer");
            break;

          case X_UngrabPointer:
            printf("UngrabPointer");
            break;

          case X_GrabButton:
            printf("GrabButton");
            break;

          case X_ChangeActivePointerGrab:
            printf("ChangeActivePointerGrab");
            break;

          case X_GrabKeyboard:
            printf("GrabKeyboard");
            break;

          case X_UngrabKeyboard:
            printf("UngrabKeyboard");
            break;

          case X_GrabKey:
            printf("GrabKey");
            break;

          case X_UngrabKey:
            printf("UngrabKey");
            break;

          case X_AllowEvents:
            printf("AllowEvents");
            break;

          case X_GrabServer:
            printf("GrabServer");
            break;

          case X_UngrabServer:
            printf("UngrabServer");
            break;

          case X_QueryPointer:
            printf("QueryPointer");
            break;

          case X_GetMotionEvents:
            printf("GetMotionEvents");
            break;

          case X_TranslateCoords:
            printf("TranslateCoords");
            break;

          case X_WarpPointer:
            printf("WarpPointer");
            break;

          case X_SetInputFocus:
            printf("SetInputFocus");
            break;

          case X_GetInputFocus:
            printf("GetInputFocus");
            break;

          case X_QueryKeymap:
            printf("QueryKeymap");
            break;

          case X_OpenFont:
            printf("OpenFont");
            break;

          case X_CloseFont:
            printf("CloseFont");
            break;

          case X_QueryFont:
            printf("QueryFont");
            break;

          case X_QueryTextExtents:
            printf("QueryTextExtents");
            break;

          case X_ListFonts:
            printf("ListFonts");
            break;

          case X_ListFontsWithInfo:
            printf("ListFontsWithInfo");
            break;

          case X_SetFontPath:
            printf("SetFontPath");
            break;

          case X_GetFontPath:
            printf("GetFontPath");
            break;

          case X_CreatePixmap:
            printf("CreatePixmap");
            break;

          case X_FreePixmap:
            printf("FreePixmap");
            break;

          case X_CreateGC:
            printf("CreateGC");
            break;

          case X_ChangeGC:
            printf("ChangeGC");
            break;

          case X_CopyGC:
            printf("CopyGC");
            break;

          case X_SetDashes:
            printf("SetDashes");
            break;

          case X_SetClipRectangles:
            printf("SetClipRectangles");
            break;

          case X_FreeGC:
            printf("FreeGC");
            break;

          case X_ClearArea:
            printf("ClearArea");
            break;

          case X_CopyArea:
            printf("CopyArea");
            break;

          case X_CopyPlane:
            printf("CopyPlane");
            break;

          case X_PolyPoint:
            printf("PolyPoint");
            break;

          case X_PolyLine:
            printf("PolyLine");
            break;

          case X_PolySegment:
            printf("PolySegment");
            break;

          case X_PolyRectangle:
            printf("PolyRectangle");
            break;

          case X_PolyArc:
            printf("PolyArc");
            break;

          case X_FillPoly:
            printf("FillPoly");
            break;

          case X_PolyFillRectangle:
            printf("PolyFillRectangle");
            break;

          case X_PolyFillArc:
            printf("PolyFillArc");
            break;

          case X_PutImage:
            printf("PutImage");
            break;

          case X_GetImage:
            printf("GetImage");
            break;

          case X_PolyText8:
            printf("PolyText8");
            break;

          case X_PolyText16:
            printf("PolyText16");
            break;

          case X_ImageText8:
            printf("ImageText8");
            break;

          case X_ImageText16:
            printf("ImageText16");
            break;

          case X_CreateColormap:
            printf("CreateColormap");
            break;

          case X_FreeColormap:
            printf("FreeColormap");
            break;

          case X_CopyColormapAndFree:
            printf("CopyColormapAndFree");
            break;

          case X_InstallColormap:
            printf("InstallColormap");
            break;

          case X_UninstallColormap:
            printf("UninstallColormap");
            break;

          case X_ListInstalledColormaps:
            printf("ListInstalledColormaps");
            break;

          case X_AllocColor:
            printf("AllocColor");
            break;

          case X_AllocNamedColor:
            printf("AllocNamedColor");
            break;

          case X_AllocColorCells:
            printf("AllocColorCells");
            break;

          case X_AllocColorPlanes:
            printf("AllocColorPlanes");
            break;

          case X_FreeColors:
            printf("FreeColors");
            break;

          case X_StoreColors:
            printf("StoreColors");
            break;

          case X_StoreNamedColor:
            printf("StoreNamedColor");
            break;

          case X_QueryColors:
            printf("QueryColors");
            break;

          case X_LookupColor:
            printf("LookupColor");
            break;

          case X_CreateCursor:
            printf("CreateCursor");
            break;

          case X_CreateGlyphCursor:
            printf("CreateGlyphCursor");
            break;

          case X_FreeCursor:
            printf("FreeCursor");
            break;

          case X_RecolorCursor:
            printf("RecolorCursor");
            break;

          case X_QueryBestSize:
            printf("QueryBestSize");
            break;

          case X_QueryExtension:
            printf("QueryExtension");
            break;

          case X_ListExtensions:
            printf("ListExtensions");
            break;

          case X_ChangeKeyboardMapping:
            printf("ChangeKeyboardMapping");
            break;

          case X_GetKeyboardMapping:
            printf("GetKeyboardMapping");
            break;

          case X_ChangeKeyboardControl:
            printf("ChangeKeyboardControl");
            break;

          case X_GetKeyboardControl:
            printf("GetKeyboardControl");
            break;

          case X_Bell:
            printf("Bell");
            break;

          case X_ChangePointerControl:
            printf("ChangePointerControl");
            break;

          case X_GetPointerControl:
            printf("GetPointerControl");
            break;

          case X_SetScreenSaver:
            printf("SetScreenSaver");
            break;

          case X_GetScreenSaver:
            printf("GetScreenSaver");
            break;

          case X_ChangeHosts:
            printf("ChangeHosts");
            break;

          case X_ListHosts:
            printf("ListHosts");
            break;

          case X_SetAccessControl:
            printf("SetAccessControl");
            break;

          case X_SetCloseDownMode:
            printf("SetCloseDownMode");
            break;

          case X_KillClient:
            printf("KillClient");
            break;

          case X_RotateProperties:
            printf("RotateProperties");
            break;

          case X_ForceScreenSaver:
            printf("ForceScreenSaver");
            break;

          case X_SetPointerMapping:
            printf("SetPointerMapping");
            break;

          case X_GetPointerMapping:
            printf("GetPointerMapping");
            break;

          case X_SetModifierMapping:
            printf("SetModifierMapping");
            break;

          case X_GetModifierMapping:
            printf("GetModifierMapping");
            break;

          case X_NoOperation:
            printf("NoOperation");
            break;

	  default:
	    printf("Unsupported");
	    break;
	}
	printf(")\n");


        fprintf(stderr,
 "        Minor op-code of failed request: %i\n",
	    da_error_event->minor_code
        );

	/* Resource ID. */
        fprintf(stderr,
 "        Resource ID: %i\n",
	    (int32_t)da_error_event->resourceid
        );



	return(0);
}
