#include "swserv.h"
  
 
 
/*
 *      Save the database.
 */
int CmdSaveDB(int condescriptor, char *arg)
{
        int status;
        long object_num;
	xsw_object_struct *obj_ptr;
        char sndbuf[CS_DATA_MAX_LEN];
        char stringa[256];


        /* Get object_num, assumed valid. */
        object_num = connection[condescriptor]->object_num;
	if(DBIsObjectGarbage(object_num))
	    return(-1);
	else
	    obj_ptr = xsw_object[object_num];

        /* Check if object's permission allows save. */
        if(obj_ptr->permission.uid > ACCESS_UID_SAVE)
        {
            sprintf(sndbuf,
                "set: Requires access level %i: Permission denied.",
                ACCESS_UID_SAVE
            );
            NetSendLiveMessage(condescriptor, sndbuf);
            return(-1);
        }


        /* Warn all connections that save is in progress. */
        NetSendLiveMessage(-1, "Server: Database save in progress...");
        
        /* Log who requested save. */
        sprintf(stringa, "%s: Requesting database save.",
            DBGetFormalNameStr(object_num)
        );
        if(sysparm.log_general)
            LogAppendLineFormatted(fname.primary_log, stringa);


        /* Save the database. */
        status = DBSaveToFile(fname.db_out);
        if(status)
        {
            /* Print error to connection. */
            sprintf(sndbuf,
                "Server: Error: DBSaveToFile(): Error code %i.",
                status
            );
            NetSendLiveMessage(condescriptor, sndbuf);
         
            /* Log error. */
            sprintf(stringa,
                "Server: Error: 
		DBSaveToFile(): Error code %i.",
                status
            );
            if(sysparm.log_general == 1)
                LogAppendLineFormatted(fname.primary_log, stringa);


            return(-1);
        }
        else
        {
            /* Notify all connections of sucessful save. */
            NetSendLiveMessage(-1, "Server: Database save completed.");

            /* Log sucessful save. */
            sprintf(stringa, "Server: Successfully saved database: `%s'",
                fname.db_out
            );
            if(sysparm.log_general)
                LogAppendLineFormatted(fname.primary_log, stringa);
        }


        /* Mark next time DB save is to be performed. */
        next.db_save = cur_systime + sysparm.int_db_save;


        return(0);
}
