#include "swserv.h"



int LogAppendLineFormatted(char *filename, char *str)
{
	int i, len;
        FILE *fp;
	char *strptr;
	char *buf;
	aux_connection_struct **ac_ptr;


	/* Make sure str is valid. */
	if((str == NULL) ? 1 : (str[0] == '\0'))
	    return(0);


        /* Open or create file for appending. */
        fp = fopen(filename, "a");
        if(fp == NULL)
            return(-1);


	/* Allocate buffer. */
	len = strlen(str) + 128;
	buf = (char *)malloc(len * sizeof(char));
	if(buf == NULL)
	{
	    fclose(fp);
	    return(-1);
	}


	/* Get time string. */
	strptr = StringCurrentTimeFormat(
	    "%m/%d/%Y %H:%M:%S"
	);
	if(strptr == NULL)
	{
	    free(buf);
	    fclose(fp);

            return(-1);
	}

	/* Print log line to file. */
	fprintf(fp, "%s: %s\n",
	    strptr,
	    str
	);

	/* Close file. */
	fclose(fp);


	/* Write to all AUX connections. */
	sprintf(buf, "%s: %s: %s\n",
	    STAT_PFX_MESSAGE,
	    strptr,
	    str
	);
	for(i = 0, ac_ptr = aux_connection;
            i < total_aux_connections;
            i++, ac_ptr++
	)
	{
	    if(*ac_ptr == NULL)
		continue;

	    if(!(*ac_ptr)->logged_in)
		continue;

	    if((*ac_ptr)->socket < 0)
		continue;


	    AUXConSend(*ac_ptr, buf);
	}


	/* Free buffer. */
	free(buf);


	return(0);
}
